Package: fromo
Type: Package
Maintainer: Steven E. Pav <shabbychef@gmail.com>
Authors@R: c(person(c("Steven", "E."), "Pav", 
    role=c("aut","cre"),
    email="shabbychef@gmail.com",
    comment = c(ORCID = "0000-0002-4197-6195")))
Version: 0.2.4
Date: 2024-11-29
License: LGPL-3
Title: Fast Robust Moments
BugReports: https://github.com/shabbychef/fromo/issues
Description: Fast, numerically robust computation of weighted moments via 'Rcpp'. 
   Supports computation on vectors and matrices, and Monoidal append of moments. 
   Moments and cumulants over running fixed length windows can be computed, 
   as well as over time-based windows.
   Moment computations are via a generalization of Welford's method, as described
   by Bennett et. (2009) <doi:10.1109/CLUSTR.2009.5289161>.
Imports: Rcpp (>= 0.12.3), methods
LinkingTo: Rcpp
Suggests: knitr, testthat, moments, PDQutils, e1071, microbenchmark
RoxygenNote: 7.3.2
URL: https://github.com/shabbychef/fromo
VignetteBuilder: knitr
Collate: 'fromo.r' 'RcppExports.R' 'zzz_centsums.R'
Author: Steven E. Pav [aut, cre] (<https://orcid.org/0000-0002-4197-6195>)
Built: R 4.4.2; x86_64-apple-darwin20.6.0; 2024-12-01 04:18:32 UTC; unix

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.25
# Copyright: Steven E. Pav, 2016-2016
# Author: Steven E. Pav
# Comments: Steven E. Pav

# because Hadley says it should be like this.
# see https://github.com/hadley/devtools/wiki/Testing

library(testthat)
library(fromo)

test_check("fromo")

#for vim modeline: (do not edit)
# vim:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.28
# Copyright: Steven E. Pav, 2016-2016
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
THOROUGHNESS <- getOption('test.thoroughness',1.0)

# slow version of t_running; requires a helper function.
	slow_op <- function(v,func,outsize=1,missfill=NA,
											time=NULL,time_deltas=NULL,window=Inf,wts=NULL,lb_time=NULL,
											na_rm=FALSE,min_df=0,lookahead=0,variable_win=FALSE,wts_as_delta=TRUE,...) {
		if (is.null(time)) {
			if (is.null(time_deltas) && !is.null(wts) && wts_as_delta) {
				time_deltas <- wts
			} else {
				stop('bad input')
			}
			time <- cumsum(time_deltas)
		}
		if (is.null(lb_time)) {
			lb_time <- time
		}
		lb_time <- lb_time + lookahead
		if (variable_win) {
			tprev <- c(-Inf,lb_time[1:(length(lb_time)-1)])
		} else {
			tprev <- lb_time - window
		}
		# fix weights.
		sapply(seq_along(lb_time),
			function(idx) {
				tf <- lb_time[idx]
				t0 <- tprev[idx]
				takeus <- (t0 < time) & (time <= tf)
				if (na_rm) {
					takeus <- takeus & !is.na(v)
					if (!is.null(wts)) {
						takeus <- takeus & !is.na(wts)
					}
				}
				if (any(takeus)) {
					vsub <- v[takeus]
					if (is.null(wts)) {
						retv <- func(vsub,...)
					} else {
						subwts <- wts[takeus]
						retv <- func(vsub,wts=subwts,...)
					}
				} else {
					retv <- rep(missfill,outsize)
				}
				retv
			})
	}

	slow_t_running_sum <- function(v,...) {
		func <- function(v,wts=NULL,...) { 
			if (is.null(wts)) {
				return(prod(sd3(v,...)[c(2:3)])) 
			}
			return(sum(v*wts))
		}
		as.numeric(slow_op(v=v,func=func,missfill=0,...))
	}
	slow_t_running_mean <- function(v,...) {
		func <- function(v,...) { sd3(v,...)[2] }
		as.numeric(slow_op(v=v,func=func,...))
	}
	slow_t_running_sd <- function(v,...) {
		func <- function(v,...) { sd3(v,...)[1] }
		matrix(slow_op(v=v,func=func,...),ncol=1)
	}
	slow_t_running_skew <- function(v,...) {
		func <- function(v,...) { 
			return(skew4(v,...)[1]) 
		}
		matrix(slow_op(v=v,func=func,...),ncol=1)
	}
	slow_t_running_kurt <- function(v,...) {
		func <- function(v,...) { kurt5(v,...)[1] }
		matrix(slow_op(v=v,func=func,...),ncol=1)
	}

	slow_t_running_sd3 <- function(v,...) {
		func <- function(v,...) { sd3(v,...) }
		t(slow_op(v=v,func=func,outsize=3,...))
	}
	slow_t_running_skew4 <- function(v,...) {
		func <- function(v,...) { 
			if (length(v) > 2) {
				return(skew4(v,...))
			} else {
				return(c(NA,sd3(v,...)))
			}
		}
		t(slow_op(v=v,func=func,outsize=4,...))
	}
	slow_t_running_kurt5 <- function(v,...) {
		func <- function(v,...) { 
			if (length(v) > 3) {
				return(kurt5(v,...))
			} else if (length(v) > 2) {
				return(c(NA,skew4(v,...)))
			} else {
				return(c(NA,NA,sd3(v,...)))
			}
		}
		t(slow_op(v=v,func=func,outsize=5,...))
	}

	reference_sd <- function(x,wts=NULL,na_rm=FALSE,normalize_wts=FALSE,min_df=0,used_df=1) {
		if (na_rm) {
			isok <- !is.na(x)
			if (!is.null(wts)) {
				isok <- isok & !is.na(wts) & wts >= 0
			}
			x <- x[isok]
			if (!is.null(wts)) {
				wts <- wts[isok]
			}
		}
		if (length(x) < min_df) {
			return(NA)
		}
		if (!is.null(wts)) {
			wsum <- sum(wts)
			mu <- sum(x*wts) / wsum
			deno <- wsum - used_df * ifelse(normalize_wts,wsum / length(x),1)
			vv <- sum(wts * (x - mu)^2) / deno
		} else {
			wsum <- length(x)
			mu <- sum(x) / wsum
			vv <- sum((x - mu)^2) / (wsum - used_df)
		}
		return(sqrt(vv))
	}
	# not quite the same as slow_t_running_sd above
	reference_t_running_sd <- function(v,...) {
		matrix(slow_op(v=v,func=reference_sd,...),ncol=1)
	}
#UNFOLD

context("first moments")#FOLDUP
test_that("sd, skew, kurt are correct",{#FOLDUP
	set.char.seed("c4007dba-2010-481e-abe5-f07d3ce94eb4")
	x <- rnorm(1000)

	expect_error(sid <- sd3(x),NA)
	expect_error(ske <- skew4(x),NA)
	expect_error(krt <- kurt5(x),NA)

	expect_equal(length(sid),3)
	expect_equal(length(ske),4)
	expect_equal(length(krt),5)

	# compare computations to gold standard
	# length
	expect_equal(sid[3],length(x))
	expect_equal(sid[3],ske[4])
	expect_equal(sid[3],krt[5])

	# mean
	expect_equal(sid[2],mean(x),tolerance=1e-9)
	expect_equal(sid[2],ske[3],tolerance=1e-9)
	expect_equal(sid[2],krt[4],tolerance=1e-9)

	# standard dev
	expect_equal(sid[1],ske[2],tolerance=1e-9)
	expect_equal(sid[1],krt[3],tolerance=1e-9)
	expect_equal(sid[1],sd(x),tolerance=1e-9)

	# skew
	expect_equal(ske[1],krt[2],tolerance=1e-9)

	if (require(moments)) {
		na_rm <- TRUE
		dumb_count  <- sum(sign(abs(x)+1),na.rm=na_rm) 
		dumb_mean   <- mean(x,na.rm=na_rm) 
		dumb_sd     <- sd(x,na.rm=na_rm) 
		dumb_skew   <- moments::skewness(x,na.rm=na_rm) 
		dumb_exkurt <- moments::kurtosis(x,na.rm=na_rm) - 3.0 

		dumb_cmom2 <- moments::moment(x,central=TRUE,na.rm=na_rm,order=2) 
		dumb_cmom3 <- moments::moment(x,central=TRUE,na.rm=na_rm,order=3)
		dumb_cmom4 <- moments::moment(x,central=TRUE,na.rm=na_rm,order=4)
		dumb_cmom5 <- moments::moment(x,central=TRUE,na.rm=na_rm,order=5)
		dumb_cmom6 <- moments::moment(x,central=TRUE,na.rm=na_rm,order=6)

		# skew
		expect_equal(ske[1],dumb_skew,tolerance=1e-9)
		# kurtosis
		expect_equal(krt[1],dumb_exkurt,tolerance=1e-9)

		# oops. problems with centered moments in terms of the used_df; need a
		# better test...
		cmoms <- cent_moments(x,max_order=6,used_df=0)
		dumbv <- c(dumb_cmom6,dumb_cmom5,dumb_cmom4,dumb_cmom3,dumb_cmom2,dumb_mean,dumb_count)
		expect_equal(max(abs(cmoms-dumbv)),0,tolerance=1e-9)

		if (require(PDQutils)) {
			cumuls <- cent_cumulants(x,max_order=length(cmoms)-1)
			dumbv0 <- c(dumb_cmom6,dumb_cmom5,dumb_cmom4,dumb_cmom3,dumb_cmom2,dumb_mean,dumb_count)
			dumbv1 <- PDQutils::moment2cumulant(c(0,rev(dumbv0)[3:length(dumbv0)]))
			dumbv <- c(rev(dumbv1[2:length(dumbv1)]),dumb_mean,dumb_count)
			
			expect_equal(max(abs(cumuls-dumbv)),0,tolerance=1e-12)
		}
	}
	if (require(e1071)) {
		dumb_skew   <- e1071::skewness(x,type=3)
		equiv_skew  <- ske[1] * ((ske[4]-1)/(ske[4]))^(3/2)
		expect_equal(dumb_skew,equiv_skew,tolerance=1e-12)
	}

	# 2FIX: add cent_moments and std_moments
	# 2FIX: check NA
	mux <- mean(x)
	# adjusted standard deviation
	sdx <- sqrt((length(x)-1)/length(x)) * sd(x)
	
	# test centered moment computation
	expect_error(cmm <- cent_moments(x,max_order=5),NA)
	expect_equal(cmm[6],length(x))
	expect_equal(cmm[5],mux,tolerance=1e-9)
	for (idx in c(2:5)) {
		expect_equal(cmm[6-idx],mean((x-mux)^idx),tolerance=1e-9)
	}
	
	# test standardized (centered) moment computation
	expect_error(stm <- std_moments(x,max_order=5),NA)
	expect_equal(stm[6],length(x))
	# mean
	expect_equal(stm[5],mux,tolerance=1e-9)
	# standard dev
	expect_equal(stm[4],sdx,tolerance=1e-9)
	for (idx in c(3:5)) {
		expect_equal(stm[6-idx],mean((x-mux)^idx)/(sdx^(idx)),tolerance=1e-9)
	}

	# test centered cumulants computation
	expect_error(ccm <- cent_cumulants(x,max_order=5),NA)
	expect_equal(ccm[6],length(x))
	# mean
	expect_equal(ccm[5],mux,tolerance=1e-9)
	# variance
	expect_equal(ccm[4],sdx^2,tolerance=1e-9)
	# add more .
	if (require(moments)) {
     mu.raw.x <- moments::all.moments(x, order.max=5)
		 mu.cent.x <- moments::raw2central(mu.raw.x)
		 cent_cum <- moments::all.cumulants(mu.cent.x)
		 expect_equal(rev(ccm)[3:6],cent_cum[3:6],tolerance=1e-12)
	}

	# test standardized cumulants computation
	expect_error(csm <- std_cumulants(x,max_order=5),NA)
	expect_equal(csm[6],length(x))
	# mean
	expect_equal(csm[5],mux,tolerance=1e-9)
	# variance
	expect_equal(csm[4],sdx^2,tolerance=1e-9)
	for (idx in c(3:5)) {
		expect_equal(csm[6-idx],ccm[6-idx]/(sdx^idx),tolerance=1e-9)
	}

	# sentinel
	expect_true(TRUE)
})#UNFOLD
test_that("unit weighted sd, skew, kurt are correct",{#FOLDUP
	set.char.seed("b652ccd2-478b-44d4-90e2-2ca2bad99d25")
	x <- rnorm(1000)
	ones <- rep(1,length(x))

	expect_equal(sd3(x),sd3(x,wts=ones),tolerance=1e-9)
	expect_equal(skew4(x),skew4(x,wts=ones),tolerance=1e-9)
	expect_equal(kurt5(x),kurt5(x,wts=ones),tolerance=1e-9)
	# 2FIX: probably normalize_wts=FALSE should be the default???? for speed?
	expect_equal(running_sd(x),running_sd(x,wts=ones,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_skew(x),running_skew(x,wts=ones,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_kurt(x),running_kurt(x,wts=ones,normalize_wts=TRUE),tolerance=1e-9)

	expect_equal(running_sd(x),running_sd(x,wts=ones,normalize_wts=FALSE),tolerance=1e-9)
	expect_equal(running_skew(x),running_skew(x,wts=ones,normalize_wts=FALSE),tolerance=1e-9)
	expect_equal(running_kurt(x),running_kurt(x,wts=ones,normalize_wts=FALSE),tolerance=1e-9)

	# 2FIX: add more.
	# sentinel
	expect_true(TRUE)
})#UNFOLD
test_that("normalize weights works",{#FOLDUP
	set.char.seed("2694ae87-62d4-4154-9c32-864f9a6e648d")
	x <- rnorm(25)
	wts <- runif(length(x))

	expect_equal(sd3(x,wts=wts,normalize_wts=TRUE),
							 sd3(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(skew4(x,wts=wts,normalize_wts=TRUE),
							 skew4(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(kurt5(x,wts=wts,normalize_wts=TRUE),
							 kurt5(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)

	expect_equal(running_sd(x,wts=wts,normalize_wts=TRUE),
							 running_sd(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_skew(x,wts=wts,normalize_wts=TRUE),
							 running_skew(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_kurt(x,wts=wts,normalize_wts=TRUE),
							 running_kurt(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_sd3(x,wts=wts,normalize_wts=TRUE),
							 running_sd3(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_skew4(x,wts=wts,normalize_wts=TRUE),
							 running_skew4(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_kurt5(x,wts=wts,normalize_wts=TRUE),
							 running_kurt5(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_sharpe(x,wts=wts,normalize_wts=TRUE),
							 running_sharpe(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_sharpe(x,wts=wts,normalize_wts=TRUE,compute_se=TRUE),
							 running_sharpe(x,wts=2*wts,normalize_wts=TRUE,compute_se=TRUE),tolerance=1e-9)
	expect_equal(running_centered(x,wts=wts,normalize_wts=TRUE),
							 running_centered(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_apx_median(x,wts=wts,normalize_wts=TRUE),
							 running_apx_median(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_tstat(x,wts=wts,normalize_wts=TRUE),
							 running_tstat(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_zscored(x,wts=wts,normalize_wts=TRUE),
							 running_zscored(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_scaled(x,wts=wts,normalize_wts=TRUE),
							 running_scaled(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	expect_equal(running_apx_quantiles(x,p=ptiles,wts=wts,normalize_wts=TRUE),
							 running_apx_quantiles(x,p=ptiles,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_cent_moments(x,wts=wts,normalize_wts=TRUE),
							 running_cent_moments(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_std_moments(x,wts=wts,normalize_wts=TRUE),
							 running_std_moments(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
	expect_equal(running_cumulants(x,wts=wts,normalize_wts=TRUE),
							 running_cumulants(x,wts=2*wts,normalize_wts=TRUE),tolerance=1e-9)
})#UNFOLD
test_that("weight scaling what you expect",{#FOLDUP
	set.char.seed("efaa75ac-bb9e-4e4a-a375-7028f099366e")
	x <- rnorm(50)
	wts <- runif(length(x))

	expect_error(sid_1 <- sd3(x,wts=wts,normalize_wts=FALSE,sg_df=0),NA)
	expect_error(ske_1 <- skew4(x,wts=wts,normalize_wts=FALSE,sg_df=0),NA)
	expect_error(krt_1 <- kurt5(x,wts=wts,normalize_wts=FALSE,sg_df=0),NA)

	expect_error(sid_2 <- sd3(x,wts=2*wts,normalize_wts=FALSE,sg_df=0),NA)
	expect_error(ske_2 <- skew4(x,wts=2*wts,normalize_wts=FALSE,sg_df=0),NA)
	expect_error(krt_2 <- kurt5(x,wts=2*wts,normalize_wts=FALSE,sg_df=0),NA)

	expect_equal(sid_1 * c(1,1,2),sid_2,tolerance=1e-9)
	expect_equal(ske_1 * c(1,1,1,2),ske_2,tolerance=1e-9)
	expect_equal(krt_1 * c(1,1,1,1,2),krt_2,tolerance=1e-9)
})#UNFOLD
test_that("weighted sd, skew, kurt are correct",{#FOLDUP
	set.char.seed("4e17d837-69c1-41d1-906f-c82224d7ce41")
	x <- rnorm(1000)
	wts <- runif(length(x))

	expect_error(sid <- sd3(x,wts=wts,normalize_wts=TRUE),NA)
	expect_error(ske <- skew4(x,wts=wts,normalize_wts=TRUE),NA)
	expect_error(krt <- kurt5(x,wts=wts,normalize_wts=TRUE),NA)
	# 2FIX: add more here to check correctness ... 

	expect_equal(length(sid),3)
	expect_equal(length(ske),4)
	expect_equal(length(krt),5)

	# compare computations to gold standard
	# length
	expect_equal(sid[3],length(x))
	expect_equal(sid[3],ske[4])
	expect_equal(sid[3],krt[5])

	# mean
	expect_equal(sid[2],weighted.mean(x,w=wts),tolerance=1e-9)
	expect_equal(sid[2],ske[3],tolerance=1e-9)
	expect_equal(sid[2],krt[4],tolerance=1e-9)

	# standard dev
	expect_equal(sid[1],ske[2],tolerance=1e-9)
	expect_equal(sid[1],krt[3],tolerance=1e-9)
	wsd <- sqrt(sum(((x - weighted.mean(x,w=wts))^2) * (wts / mean(wts))) / (length(x) - 1))
	# 2FIX!!!
	expect_equal(sid[1],wsd,tolerance=1e-9)

	# skew
	expect_equal(ske[1],krt[2],tolerance=1e-9)
 
	na_rm <- TRUE
	dumb_count  <- length(x)
	dumb_mean   <- weighted.mean(x,w=wts)
	dumb_sd     <- sqrt(sum(((x - weighted.mean(x,w=wts))^2) * (wts / mean(wts))) / (length(x) - 1))

	wcmom <- function(vec,wts,ord) {
		wz <- wts / mean(wts)
		mean(wz * ((x - weighted.mean(x,w=wz))^ord))
	}
	dumb_wcmom2  <- wcmom(x,wts,2)
	dumb_wcmom3  <- wcmom(x,wts,3)
	dumb_wcmom4  <- wcmom(x,wts,4)
	dumb_wcmom5  <- wcmom(x,wts,5)
	dumb_wcmom6  <- wcmom(x,wts,6)

	expect_error(cmoms <- cent_moments(x,wts=wts,max_order=6,used_df=0,normalize_wts=TRUE),NA)
	dumbv <- c(dumb_wcmom6,dumb_wcmom5,dumb_wcmom4,dumb_wcmom3,dumb_wcmom2,dumb_mean,dumb_count)
	expect_equal(cmoms,dumbv,tolerance=1e-9)

	dumb_skew <- dumb_wcmom3 / (dumb_wcmom2^(3/2))
	dumb_exkurt <- (dumb_wcmom4 / (dumb_wcmom2^(2))) - 3

	# skew
	expect_equal(ske[1],dumb_skew,tolerance=1e-9)
	# kurtosis
	expect_equal(krt[1],dumb_exkurt,tolerance=1e-9)
})#UNFOLD
test_that("weights are replication weights",{#FOLDUP
	set.char.seed("babe6284-10dc-48e0-8220-c5e2312364dd")
	x <- rnorm(15)
	wts <- c(rep(1,3),rep(2,3),rep(3,length(x)-6))
	xx <- c(x,x[wts>=2],x[wts>=3])

	expect_error(sid1 <- sd3(x,wts=wts,normalize_wts=FALSE),NA)
	expect_error(ske1 <- skew4(x,wts=wts,normalize_wts=FALSE),NA)
	expect_error(krt1 <- kurt5(x,wts=wts,normalize_wts=FALSE),NA)
	expect_error(cmm1 <- cent_moments(x,wts=wts,normalize_wts=FALSE,max_order=5),NA)
	expect_error(stm1 <- std_moments(x,wts=wts,normalize_wts=FALSE,max_order=5),NA)
	expect_error(ccm1 <- cent_cumulants(x,wts=wts,normalize_wts=FALSE,max_order=5),NA)
	expect_error(csm1 <- std_cumulants(x,wts=wts,normalize_wts=FALSE,max_order=5),NA)
	expect_error(obj1 <- as.centsums(x,wts=wts,normalize_wts=FALSE,order=5),NA)

	expect_error(sid2 <- sd3(xx),NA)
	expect_error(ske2 <- skew4(xx),NA)
	expect_error(krt2 <- kurt5(xx),NA)
	expect_error(cmm2 <- cent_moments(xx,max_order=5),NA)
	expect_error(stm2 <- std_moments(xx,max_order=5),NA)
	expect_error(ccm2 <- cent_cumulants(xx,max_order=5),NA)
	expect_error(csm2 <- std_cumulants(xx,max_order=5),NA)
	expect_error(obj2 <- as.centsums(xx,order=5),NA)

	expect_equal(sid1,sid2,tolerance=1e-9)
	expect_equal(ske1,ske2,tolerance=1e-9)
	expect_equal(krt1,krt2,tolerance=1e-9)
	expect_equal(cmm1,cmm2,tolerance=1e-9)
	expect_equal(stm1,stm2,tolerance=1e-9)
	expect_equal(ccm1,ccm2,tolerance=1e-9)
	expect_equal(csm1,csm2,tolerance=1e-9)

	# 2FIX: add more here to check correctness ... 
})#UNFOLD
#UNFOLD

tomat <- function(cbound) {
	dumbv <- as.matrix(cbound)
	attr(dumbv,'dimnames') <- NULL 
	dumbv
}

context("running ops are correct")
test_that("running ops are correct",{#FOLDUP
	skip_on_cran()
	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	set.char.seed("7ffe0035-2d0c-4586-a1a5-6321c7cf8694")
	for (xlen in c(20,100)) {
		for (xmu in c(1e3,1e6)) {
			toler <- xmu ^ (1/3)
			x <- rnorm(xlen,mean=xmu)
			for (window in c(15,50,Inf)) {
				for (restart_period in c(20,1000)) {
					for (na_rm in c(FALSE,TRUE)) {
						dumb_count <- sapply(seq_along(x),function(iii) { sum(sign(abs(x[max(1,iii-window+1):iii])+1),na.rm=na_rm) },simplify=TRUE)
						dumb_sum <- sapply(seq_along(x),function(iii) { sum(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
						dumb_mean <- sapply(seq_along(x),function(iii) { mean(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
						dumb_sd <- sapply(seq_along(x),function(iii) { sd(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
						dumb_skew <- sapply(seq_along(x),function(iii) { moments::skewness(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
						dumb_exkurt <- sapply(seq_along(x),function(iii) { moments::kurtosis(x[max(1,iii-window+1):iii],na.rm=na_rm) - 3.0 },simplify=TRUE)

						dumb_cmom2 <- sapply(seq_along(x),function(iii) { moments::moment(x[max(1,iii-window+1):iii],central=TRUE,na.rm=na_rm,order=2) },simplify=TRUE)
						dumb_cmom3 <- sapply(seq_along(x),function(iii) { moments::moment(x[max(1,iii-window+1):iii],central=TRUE,na.rm=na_rm,order=3) },simplify=TRUE)
						dumb_cmom4 <- sapply(seq_along(x),function(iii) { moments::moment(x[max(1,iii-window+1):iii],central=TRUE,na.rm=na_rm,order=4) },simplify=TRUE)
						dumb_cmom5 <- sapply(seq_along(x),function(iii) { moments::moment(x[max(1,iii-window+1):iii],central=TRUE,na.rm=na_rm,order=5) },simplify=TRUE)
						dumb_cmom6 <- sapply(seq_along(x),function(iii) { moments::moment(x[max(1,iii-window+1):iii],central=TRUE,na.rm=na_rm,order=6) },simplify=TRUE)

						# SD
						expect_error(fastv <- running_sd(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(dumb_sd)
						expect_equal(dumbv[2:xlen],fastv[2:xlen],tolerance=1e-7 * toler)

						expect_error(fastv <- running_sd3(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(cbind(dumb_sd,dumb_mean,dumb_count))
						expect_equal(dumbv[2:xlen,],fastv[2:xlen,],tolerance=1e-7 * toler)

						# skew
						expect_error(fastv <- running_skew(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(dumb_skew)
						expect_equal(dumbv[3:xlen],fastv[3:xlen],tolerance=1e-6 * toler)

						expect_error(fastv <- running_skew4(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(cbind(dumb_skew,dumb_sd,dumb_mean,dumb_count))
						expect_equal(dumbv[3:xlen,],fastv[3:xlen,],tolerance=1e-7 * toler)

						# excess kurtosis
						expect_error(fastv <- running_kurt(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(dumb_exkurt)
						expect_equal(dumbv[4:xlen],fastv[4:xlen],tolerance=1e-6 * toler)

						expect_error(fastv <- running_kurt5(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(cbind(dumb_exkurt,dumb_skew,dumb_sd,dumb_mean,dumb_count))
						expect_equal(dumbv[4:xlen,],fastv[4:xlen,],tolerance=1e-6 * toler)

						# higher order moments

						expect_error(fastv <- running_cent_moments(x,window=window,max_order=6L,used_df=0L,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(cbind(dumb_cmom6,dumb_cmom5,dumb_cmom4,dumb_cmom3,dumb_cmom2,dumb_mean,dumb_count))
						expect_equal(dumbv[6:xlen,],fastv[6:xlen,],tolerance=1e-6 * toler)

						expect_error(fastv <- running_cent_moments(x,window=window,max_order=6L,max_order_only=TRUE,used_df=0L,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(dumb_cmom6)
						expect_equal(dumbv[6:xlen,],fastv[6:xlen,],tolerance=1e-7 * toler)

						expect_error(fastv <- running_std_moments(x,window=window,max_order=6L,used_df=0L,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- tomat(cbind(dumb_cmom6 / (dumb_cmom2^3),dumb_cmom5 / (dumb_cmom2^2.5),dumb_cmom4 / (dumb_cmom2^2.0),dumb_cmom3 / (dumb_cmom2^1.5),sqrt(dumb_cmom2),dumb_mean,dumb_count))
						expect_equal(dumbv[6:xlen,],fastv[6:xlen,],tolerance=1e-7 * toler)

						# running sum and mean
						expect_error(fastv <- running_sum(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- dumb_sum
						expect_equal(dumbv[2:xlen],fastv[2:xlen],tolerance=1e-7 * toler)

						expect_error(fastv <- running_mean(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
						dumbv <- dumb_mean
						expect_equal(dumbv[2:xlen],fastv[2:xlen],tolerance=1e-7 * toler)

						if (require(PDQutils)) {
							# cumulants
							expect_error(fastv <- running_cumulants(x,window=window,max_order=6L,used_df=0L,restart_period=restart_period,na_rm=na_rm),NA)
							pre_dumbv <- cbind(dumb_cmom6,dumb_cmom5,dumb_cmom4,dumb_cmom3,dumb_cmom2,dumb_mean,dumb_count)
							dumbv <- t(sapply(seq_along(x),function(iii) { 
															rv <- rev(PDQutils::moment2cumulant(c(0,rev(pre_dumbv[iii,1:(ncol(pre_dumbv)-2)]))))
															rv <- rv[-length(rv)]
															c(rv,pre_dumbv[iii,ncol(pre_dumbv) + (-1:0)])
								},simplify='matrix'))
							expect_equal(max(abs(dumbv[6:xlen,] - fastv[6:xlen,])),0,tolerance=1e-8 * toler)

							# quantiles
							expect_error(fastv <- running_apx_quantiles(x,ptiles,max_order=ncol(dumbv)-1,used_df=0L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
							dumbq <- t(sapply(seq_along(x),function(iii) { 
								PDQutils::qapx_cf(ptiles,raw.cumulants=rev(dumbv[iii,1:(ncol(dumbv)-1)]))
							}, simplify=TRUE))
							expect_equal(max(abs(dumbq[8:xlen,] - fastv[8:xlen,])),0,tolerance=1e-8 * toler)
						}
					}
				}
			}
		}
	}
})#UNFOLD
test_that("running adjustments are correct",{#FOLDUP
	skip_on_cran()

	set.char.seed("967d2149-fbff-4d82-b227-ca3e1034bddb")
	for (xlen in c(20,100)) {
		x <- rnorm(xlen)
		for (window in c(5,50,Inf)) {
			for (restart_period in c(10,1000)) {
				for (na_rm in c(FALSE,TRUE)) {
					dumb_count <- sapply(seq_along(x),function(iii) { sum(sign(abs(x[max(1,iii-window+1):iii])+1),na.rm=na_rm) },simplify=TRUE)
					dumb_mean <- sapply(seq_along(x),function(iii) { mean(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
					dumb_sd <- sapply(seq_along(x),function(iii) { sd(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)

					expect_error(fastv <- running_centered(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
					# the dumb value:
					dumbv <- x - dumb_mean;
					expect_equal(max(abs(dumbv - fastv)),0,tolerance=1e-12)

					expect_error(fastv <- running_scaled(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
					# the dumb value:
					dumbv <- x / dumb_sd
					expect_equal(max(abs(dumbv[2:length(x)] - fastv[2:length(x)])),0,tolerance=1e-12)

					expect_error(fastv <- running_zscored(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
					# the dumb value:
					dumbv <- (x - dumb_mean) / dumb_sd
					expect_equal(max(abs(dumbv[2:length(x)] - fastv[2:length(x)])),0,tolerance=1e-12)

					expect_error(fastv <- running_sharpe(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
					# the dumb value:
					dumbv <- dumb_mean / dumb_sd
					expect_equal(max(abs(dumbv[2:length(x)] - fastv[2:length(x)])),0,tolerance=1e-12)

					expect_error(fastv <- running_tstat(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
					# the dumb value:
					dumbv <- (dumb_mean * sqrt(dumb_count)) / dumb_sd
					expect_equal(max(abs(dumbv[2:length(x)] - fastv[2:length(x)])),0,tolerance=1e-12)

					expect_error(fastv <- running_sharpe(x,window=window,restart_period=restart_period,na_rm=na_rm,compute_se=TRUE),NA)
					# the dumb value:
					dumb_sr <- dumb_mean / dumb_sd
					expect_equal(max(abs(dumb_sr[2:length(x)] - fastv[2:length(x),1])),0,tolerance=1e-12)

					if (require(moments)) {
						dumb_skew <- sapply(seq_along(x),function(iii) { moments::skewness(x[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
						dumb_exkurt <- sapply(seq_along(x),function(iii) { moments::kurtosis(x[max(1,iii-window+1):iii],na.rm=na_rm) - 3.0 },simplify=TRUE)
						dumb_merse <- sqrt((1 + 0.25 * (2+dumb_exkurt) * dumb_sr^2 - dumb_skew * dumb_sr) / dumb_count)
						expect_equal(max(abs(dumb_merse[5:length(x)] - fastv[5:length(x),2])),0,tolerance=1e-9)
					}
				}
			}
		}
	}
})#UNFOLD


context("weighted running ops are correct")
test_that("running weights work correctly",{#FOLDUP
	skip_on_cran()

	set.char.seed("b82d252c-681b-4b98-9bb3-ffd17feeb4a1")
	na_rm <- FALSE

	restart_period <- 1000
	for (xlen in c(20,50)) {
		x <- rnorm(xlen)
		for (wts in list(rep(1L,xlen), runif(xlen,min=2,max=7))) { 
			for (window in c(5,30,Inf)) { # FOLDUP

				# 2FIX: add to this!
				slow_count <- sapply(seq_along(x),function(iii) { sum(sign(abs(x[max(1,iii-window+1):iii])+1),na.rm=na_rm) },simplify=TRUE)
				slow_sumwt <- sapply(seq_along(x),function(iii) { sum(wts[max(1,iii-window+1):iii],na.rm=na_rm) },simplify=TRUE)
				slow_mean <- sapply(seq_along(x),function(iii) { 
															mydx <- max(1,iii-window+1):iii
															mywts <- wts[mydx]
															sum(mywts * x[mydx],na.rm=na_rm) / slow_sumwt[iii]
							 },simplify=TRUE)
				slow_var <- sapply(seq_along(x),function(iii) { 
															mydx <- max(1,iii-window+1):iii
															mywts <- wts[mydx]
															sum(mywts * (x[mydx] - slow_mean[iii])^2,na.rm=na_rm) / (slow_sumwt[iii] - 1)
							 },simplify=TRUE)
				slow_sd <- sqrt(slow_var)
				# the normalize version;
				slow_nvar <- sapply(seq_along(x),function(iii) { 
															mydx <- max(1,iii-window+1):iii
															mywts <- wts[mydx]
															(slow_count[iii]/slow_sumwt[iii]) * sum(mywts * (x[mydx] - slow_mean[iii])^2,na.rm=na_rm) / (slow_count[iii] - 1)
							 },simplify=TRUE)
				slow_nsd <- sqrt(slow_nvar)

				slow_cent3 <- sapply(seq_along(x),function(iii) { 
															mydx <- max(1,iii-window+1):iii
															mywts <- wts[mydx]
															sum(mywts * (x[mydx] - slow_mean[iii])^3,na.rm=na_rm) / (slow_sumwt[iii])
							 },simplify=TRUE)
				slow_cent4 <- sapply(seq_along(x),function(iii) { 
															mydx <- max(1,iii-window+1):iii
															mywts <- wts[mydx]
															sum(mywts * (x[mydx] - slow_mean[iii])^4,na.rm=na_rm) / (slow_sumwt[iii])
							 },simplify=TRUE)

				expect_error(fastv <- running_mean(x,wts=wts,min_df=0,window=window,na_rm=na_rm),NA)
				expect_equal(fastv,slow_mean,tolerance=1e-8)

				expect_error(fastv <- running_centered(x,wts=wts,window=window,restart_period=restart_period,na_rm=na_rm),NA)
				slowv <- x - slow_mean;
				expect_equal(as.numeric(fastv),slowv,tolerance=1e-8)

				for (nw in c(TRUE,FALSE)) {
					if (nw) {
						use_sd <- slow_nsd
						use_df <- slow_count
					} else {
						use_sd <- slow_sd
						use_df <- slow_sumwt
					}

					expect_error(fastv <- running_sd(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(as.numeric(fastv),use_sd,tolerance=1e-8)

					expect_error(fastv <- running_sd3(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(as.numeric(fastv[,1]),use_sd,tolerance=1e-8)
					expect_equal(as.numeric(fastv[,2]),slow_mean,tolerance=1e-8)
					expect_equal(as.numeric(fastv[,3]),use_df,tolerance=1e-8)

					expect_error(fastv <- running_scaled(x,wts=wts,window=window,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- x / use_sd
					expect_equal(as.numeric(fastv[2:length(x)]),slowv[2:length(x)],tolerance=1e-8)

					expect_error(fastv <- running_zscored(x,wts=wts,window=window,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- (x - slow_mean) / use_sd
					expect_equal(slowv[2:length(x)],fastv[2:length(x)],tolerance=1e-12)

					expect_error(fastv <- running_sharpe(x,wts=wts,window=window,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- slow_mean / use_sd
					expect_equal(slowv[2:length(x)],fastv[2:length(x)],tolerance=1e-12)

					expect_error(fastv <- running_tstat(x,wts=wts,window=window,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- (slow_mean * sqrt(use_df)) / use_sd
					expect_equal(slowv[2:length(x)],fastv[2:length(x)],tolerance=1e-12)

					expect_error(fastv <- running_cent_moments(x,wts=wts,window=window,max_order=3L,max_order_only=TRUE,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- slow_cent3 
					expect_equal(slowv[3:length(x)],fastv[3:length(x)],tolerance=1e-12)

					expect_error(fastv <- running_cent_moments(x,wts=wts,window=window,max_order=4L,max_order_only=TRUE,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					slowv <- slow_cent4 
					expect_equal(slowv[4:length(x)],fastv[4:length(x)],tolerance=1e-12)
				}
			}# UNFOLD
		}
	}
})#UNFOLD

context("t_running for trivial case")
test_that("vs running ops",{#FOLDUP
	skip_on_cran()

	set.char.seed("712463ec-f266-4de7-89d2-ce3c824327b0")
	na_rm <- FALSE
	ptiles <- c(0.1,0.25,0.5,0.75,0.9)

	for (xlen in c(20,50)) {
		x <- rnorm(xlen)
		times <- seq_along(x)
		for (wts in list(NULL,rep(1L,xlen), runif(xlen,min=1.2,max=3.5))) {
			# 2FIX? Inf window?
			for (window in c(5,30,Inf)) { # FOLDUP
				# to avoid roundoff issues on double times.
				t_window <- window - 0.1

				expect_error(box <- running_sum(x,wts=wts,window=window,na_rm=na_rm),NA)
				expect_error(tbox <- t_running_sum(x,time=times,wts=wts,window=t_window,na_rm=na_rm),NA)
				expect_equal(box,tbox,tolerance=1e-8)

				expect_error(box <- running_mean(x,wts=wts,min_df=0,window=window,na_rm=na_rm),NA)
				expect_error(tbox <- t_running_mean(x,time=times,wts=wts,min_df=0,window=t_window,na_rm=na_rm),NA)
				expect_equal(box,tbox,tolerance=1e-8)

				for (nw in c(TRUE,FALSE)) { 
					expect_error(box <- running_sd(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_error(tbox <- t_running_sd(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_skew(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_skew(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_kurt(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_kurt(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_sd3(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_sd3(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)
					
					expect_error(box <- running_skew4(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_skew4(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_kurt5(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_kurt5(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_centered(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_centered(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_scaled(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_scaled(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_zscored(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_zscored(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_tstat(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_tstat(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					for (cse in c(TRUE,FALSE)) {
						expect_error(box <- running_sharpe(x,wts=wts,window=window,na_rm=na_rm,compute_se=cse,normalize_wts=nw),NA)
						# the 0.1 is to avoid roundoff issues on the double times.
						expect_error(tbox <- t_running_sharpe(x,time=times,wts=wts,window=t_window,na_rm=na_rm,compute_se=cse,normalize_wts=nw),NA)
						expect_equal(box,tbox,tolerance=1e-8)
					}

					expect_error(box <- running_apx_median(x,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_apx_median(x,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)

					expect_error(box <- running_apx_quantiles(x,ptiles,max_order=3,wts=wts,window=window,na_rm=na_rm,normalize_wts=nw),NA)
					# the 0.1 is to avoid roundoff issues on the double times.
					expect_error(tbox <- t_running_apx_quantiles(x,ptiles,max_order=3,time=times,wts=wts,window=t_window,na_rm=na_rm,normalize_wts=nw),NA)
					expect_equal(box,tbox,tolerance=1e-8)
				}
			}# UNFOLD
		}
	}
})#UNFOLD

context("t_running vs slow version")
test_that("basic t_running_sum",{#FOLDUP
	x <- 1:9
	lb_time <- c(3,6,9)
	expect_error(fast <- t_running_sum(x,time=seq_along(x),window=Inf,lb_time=lb_time,variable_win=TRUE),NA)
	expect_equal(fast,c(1+2+3,4+5+6,7+8+9),tolerance=1e-8)
	expect_error(fast <- t_running_mean(x,time=seq_along(x),window=Inf,lb_time=lb_time,variable_win=TRUE),NA)
	expect_equal(fast,c(1+2+3,4+5+6,7+8+9)/3,tolerance=1e-8)
	expect_error(fast <- t_running_sd(x,time=seq_along(x),window=Inf,lb_time=lb_time,variable_win=TRUE),NA)
	expect_equal(as.numeric(fast),c(1,1,1),tolerance=1e-8)
})#UNFOLD
test_that("check equality",{#FOLDUP
	skip_on_cran()

	set.char.seed("91b0bd37-0b8e-49d6-8333-039a7d7f7dd5")
	na_rm <- FALSE
	for (xlen in c(40,90)) {# FOLDUP
		x <- rnorm(xlen)
		for (times in list(NULL,cumsum(runif(length(x),min=0.2,max=0.4)))) {
			for (wts in list(NULL,rep(1L,xlen),runif(xlen,min=1.1,max=2.1))) { 
				wts_as_delta <- is.null(times) & !is.null(wts)
				if (!is.null(times) || (wts_as_delta && !is.null(wts))) {
					for (window in c(11.5,20.5,Inf)) { # FOLDUP
						for (lb_time in list(NULL,3+cumsum(runif(10,min=0.4,max=1.1)))) {
							for (variable_win in c(TRUE, FALSE)) {
								if (!variable_win || is.infinite(window)) {
									slow <- slow_t_running_sum(x,time=times,wts=wts,window=window,lb_time=lb_time,variable_win=variable_win,na_rm=na_rm,wts_as_delta=wts_as_delta)
									expect_error(fast <- t_running_sum(x,time=times,wts=wts,window=window,lb_time=lb_time,variable_win=variable_win,na_rm=na_rm,wts_as_delta=wts_as_delta),NA)
									expect_equal(fast,slow,tolerance=1e-8)
									
									slow <- slow_t_running_mean(x,time=times,wts=wts,window=window,lb_time=lb_time,variable_win=variable_win,na_rm=na_rm,wts_as_delta=wts_as_delta)
									expect_error(fast <- t_running_mean(x,time=times,wts=wts,window=window,lb_time=lb_time,variable_win=variable_win,na_rm=na_rm,wts_as_delta=wts_as_delta),NA)
									expect_equal(fast,slow,tolerance=1e-8)
								}
							}
							for (nw in c(TRUE,FALSE)) { 
								slow <- slow_t_running_sd(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw)
								expect_error(fast <- t_running_sd(x,time=times,wts=wts,window=window,lb_time=lb_time,min_df=1,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw),NA)
								expect_equal(fast,slow,tolerance=1e-8)

								slow <- slow_t_running_skew(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw)
								expect_error(fast <- t_running_skew(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw),NA)
								expect_equal(fast,slow,tolerance=1e-8)

								slow <- slow_t_running_kurt(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw)
								expect_error(fast <- t_running_kurt(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw),NA)
								expect_equal(fast,slow,tolerance=1e-8)

								slow <- slow_t_running_sd3(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw)
								expect_error(fast <- t_running_sd3(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,wts_as_delta=wts_as_delta,normalize_wts=nw),NA)
								# ignore the df computation in slow when empty
								slow[fast[,3]==0,3] <- 0
								slow[is.na(fast[,1]),1] <- NA
								expect_equal(fast,slow,tolerance=1e-8)

								slow <- slow_t_running_skew4(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,normalize_wts=nw)
								expect_error(fast <- t_running_skew4(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,normalize_wts=nw),NA)
								# ignore the df computation in slow when empty
								okrow <- !is.na(fast[,4]) & fast[,4] > 3 & row(fast)[,4] > 3
								expect_equal(fast[okrow,],slow[okrow,],tolerance=1e-8)

								slow <- slow_t_running_kurt5(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,normalize_wts=nw)
								expect_error(fast <- t_running_kurt5(x,time=times,wts=wts,window=window,lb_time=lb_time,na_rm=na_rm,normalize_wts=nw),NA)
								okrow <- !is.na(fast[,5]) & fast[,5] > 4 & row(fast)[,5] > 4
								expect_equal(fast[okrow,],slow[okrow,],tolerance=1e-8)
							}
						}
					}# UNFOLD
				}
			}
		}
	}# UNFOLD
})#UNFOLD

context("t_running_sd")
# t_running_sd is a bellwether for the other methods
# as it goes, so goes the other Welford based functions
test_that("check it",{#FOLDUP
	skip_on_cran()

	set.char.seed("79f60eda-7799-46e6-9096-6817b2d4473b")

	na_rm <- FALSE
	for (xlen in c(20,50)) {# FOLDUP
		x <- rnorm(xlen)
		for (times in list(NULL,cumsum(runif(length(x),min=0.2,max=0.4)))) {
			for (wts in list(NULL,rep(1L,xlen),runif(xlen,min=1.2,max=2.1))) { 
				wts_as_delta <- is.null(times) & !is.null(wts)
				if (!is.null(times) || (wts_as_delta && !is.null(wts))) {
					for (window in c(11.5,20.5,Inf)) { # FOLDUP
						for (lb_time in list(NULL,cumsum(runif(20,min=0.2,max=1)))) {
							for (nw in c(TRUE,FALSE)) { 
								expect_error(slow <- reference_t_running_sd(x,time=times,wts=wts,wts_as_delta=TRUE,window=window,lb_time=lb_time,na_rm=na_rm,min_df=1,normalize_wts=nw),NA)
								expect_error(fast <- t_running_sd(x,time=times,wts=wts,wts_as_delta=TRUE,used_df=1,window=window,lb_time=lb_time,min_df=1,na_rm=na_rm,normalize_wts=nw),NA)
								expect_equal(fast,slow,tolerance=1e-7)
							}
						}
					}# UNFOLD
				}
			}
		}
	}# UNFOLD
})#UNFOLD

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.25
# Copyright: Steven E. Pav, 2016-2019
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
#UNFOLD

# code runs at all
context("code runs: sd, skew, kurt")
test_that("sd, skew, kurt run without error",{#FOLDUP
	set.char.seed("569dd47d-f9e5-40e4-b2ac-e5dbb4771a53")
	x <- rnorm(100)
	y <- as.integer(x)
	z <- as.logical(y)
	q <- c('a','b','c')
	wts <- 100 * runif(length(x))

	for (na_rm in c(FALSE,TRUE)) {
		for (fnc in list(function(x) { x },as.integer,function(x) { as.logical(x > 0) })) {
			cls_x <- fnc(x)
			expect_error(sd3(cls_x,na_rm=na_rm),NA)
			expect_error(skew4(cls_x,na_rm=na_rm),NA)
			expect_error(kurt5(cls_x,na_rm=na_rm),NA)
			expect_error(cent_moments(cls_x,max_order=5L,used_df=1L,na_rm=na_rm),NA)
			expect_error(std_moments(cls_x,max_order=5L,used_df=1L,na_rm=na_rm),NA)
			expect_error(cent_cumulants(cls_x,max_order=5L,used_df=1L,na_rm=na_rm),NA)
			expect_error(std_cumulants(cls_x,max_order=5L,used_df=1L,na_rm=na_rm),NA)

			# weights!?
			for (wfnc in list(function(x) { x },as.integer,function(x) { as.logical(x > 10) })) {
				cls_wts <- wfnc(wts)
				expect_error(sd3(cls_x,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(skew4(cls_x,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(kurt5(cls_x,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(kurt5(cls_x,na_rm=na_rm,wts=cls_wts,check_wts=TRUE),NA)
				
				expect_error(cent_moments(cls_x,max_order=5L,used_df=1L,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(std_moments(cls_x,max_order=5L,used_df=1L,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(cent_cumulants(cls_x,max_order=5L,used_df=1L,na_rm=na_rm,wts=cls_wts),NA)
				expect_error(std_cumulants(cls_x,max_order=5L,used_df=1L,na_rm=na_rm,wts=cls_wts),NA)
			}
		}
	}
	# check some things about weights;
	expect_error(sd3(x,wts=q))
	expect_error(sd3(x,wts=rep(-1,length(x)),check_wts=TRUE))

	for (checkme in list(sd3,skew4,kurt5,cent_moments,std_moments,cent_cumulants,std_cumulants)) {
		expect_error(checkme(q))
		expect_error(checkme(x,wts=q))
		expect_error(checkme(x,wts=rep(-1,length(x)),check_wts=TRUE))
	}
})#UNFOLD
context("code runs: cosum and comoment")
test_that("cosum and comoment run without error",{#FOLDUP
	set.char.seed("ff34b509-a113-41c9-8517-aa72792c42f7")
	x <- matrix(rnorm(30*4),ncol=4)
	y <- matrix(as.integer(x),ncol=ncol(x))
	z <- matrix(as.logical(y),ncol=ncol(x))
	q <- matrix(letters[1:24],ncol=4)

	for (na_omit in c(FALSE,TRUE)) {
		expect_error(cent_cosums(x,max_order=2L,na_omit=na_omit),NA)
		expect_error(cent_comoments(x,max_order=2L,used_df=1L,na_omit=na_omit),NA)

		expect_error(cent_cosums(y,max_order=2L,na_omit=na_omit),NA)
		expect_error(cent_comoments(y,max_order=2L,used_df=1L,na_omit=na_omit),NA)

		expect_error(cent_cosums(z,max_order=2L,na_omit=na_omit),NA)
		expect_error(cent_comoments(z,max_order=2L,used_df=1L,na_omit=na_omit),NA)
	}

	expect_error(cent_cosums(x,max_order=4L))
	expect_error(cent_cosums(q,max_order=2L))
	expect_error(cent_comoments(q,max_order=2L))
})#UNFOLD
# 2FIX: check the effects of NA
#context("order of parameters")# FOLDUP
# named parameters can be given in any order?

# UNFOLD

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.28
# Copyright: Steven E. Pav, 2016-2016
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
#UNFOLD

context("monoid join/unjoin")
test_that("join/unjoin",{#FOLDUP
	set.char.seed("1325a51e-1584-4f89-9ea3-f15223a223d9")

	x1 <- rnorm(1e3,mean=1)
	x2 <- rnorm(1e3,mean=1)
	for (max_ord in c(1L,2L,3L,6L)) {
		for (narm in c(FALSE,TRUE)) { 
			expect_error(rs1 <- cent_sums(x1,max_ord,na_rm=narm),NA)
			expect_equal(length(rs1),max_ord+1)
			expect_error(rs2 <- cent_sums(x2,max_ord,na_rm=narm),NA)
			expect_equal(length(rs2),max_ord+1)
			expect_error(rs3 <- cent_sums(c(x1,x2),max_ord,na_rm=narm),NA)
			# make sure these don't change? 
			copy_rs1 <- rs1 + 0
			copy_rs2 <- rs2 + 0
			expect_error(rs3alt <- join_cent_sums(rs1,rs2),NA)
			expect_equal(rs1,copy_rs1,tolerance=1e-7)
			expect_equal(rs2,copy_rs2,tolerance=1e-7)
			expect_equal(rs3,rs3alt,tolerance=1e-7)

			copy_rs1 <- rs1 + 0
			copy_rs2 <- rs2 + 0
			copy_rs3 <- rs3 + 0

			expect_error(rs1alt <- unjoin_cent_sums(rs3,rs2),NA)
			expect_error(rs2alt <- unjoin_cent_sums(rs3,rs1),NA)
			expect_equal(rs1,copy_rs1,tolerance=1e-7)
			expect_equal(rs2,copy_rs2,tolerance=1e-7)
			expect_equal(rs3,copy_rs3,tolerance=1e-7)

			expect_equal(rs1,rs1alt,tolerance=1e-7)
			expect_equal(rs2,rs2alt,tolerance=1e-7)

			# now an empty guy; this should return empty.
			x0 <- c()
			expect_error(rs0 <- cent_sums(x0,max_ord,na_rm=narm),NA)
			expect_equal(length(rs0),max_ord+1)
			expect_error(rs1 <- cent_sums(x1,max_ord,na_rm=narm),NA)
			copy_rs1 <- rs1 + 0
			expect_error(rs1alt <- join_cent_sums(rs1,rs0),NA)
			expect_equal(rs1,rs1alt,tolerance=1e-7)
		}
	}
})#UNFOLD
test_that("weighted join/unjoin",{#FOLDUP
	set.char.seed("1100eb6f-4108-414b-94d8-e31524e93461")

	x1 <- rnorm(1e3,mean=1)
	w1 <- runif(length(x1),min=0.5,max=1.5)
	x2 <- rnorm(1e3,mean=1)
	w2 <- runif(length(x2),min=0.5,max=1.5)
	for (max_ord in c(1L,2L,3L,6L)) {
		expect_error(rs1 <- cent_sums(x1,max_ord,wts=w1,normalize_wts=FALSE),NA)
		expect_equal(length(rs1),max_ord+1)
		expect_error(rs2 <- cent_sums(x2,max_ord,wts=w2,normalize_wts=FALSE),NA)
		expect_equal(length(rs2),max_ord+1)
		expect_error(rs3 <- cent_sums(c(x1,x2),max_ord,wts=c(w1,w2),normalize_wts=FALSE),NA)
		# make sure these don't change? 
		copy_rs1 <- rs1 + 0
		copy_rs2 <- rs2 + 0
		expect_error(rs3alt <- join_cent_sums(rs1,rs2),NA)
		expect_equal(rs1,copy_rs1,tolerance=1e-7)
		expect_equal(rs2,copy_rs2,tolerance=1e-7)
		expect_equal(rs3,rs3alt,tolerance=1e-7)

		copy_rs1 <- rs1 + 0
		copy_rs2 <- rs2 + 0
		copy_rs3 <- rs3 + 0

		expect_error(rs1alt <- unjoin_cent_sums(rs3,rs2),NA)
		expect_error(rs2alt <- unjoin_cent_sums(rs3,rs1),NA)
		expect_equal(rs1,copy_rs1,tolerance=1e-7)
		expect_equal(rs2,copy_rs2,tolerance=1e-7)
		expect_equal(rs3,copy_rs3,tolerance=1e-7)

		expect_equal(rs1,rs1alt,tolerance=1e-7)
		expect_equal(rs2,rs2alt,tolerance=1e-7)

		# now an empty guy; this should return empty.
		x0 <- c()
		expect_error(rs0 <- cent_sums(x0,max_ord,wts=c()),NA)
		expect_equal(length(rs0),max_ord+1)
		expect_error(rs1 <- cent_sums(x1,max_ord,wts=w1,normalize_wts=FALSE),NA)
		copy_rs1 <- rs1 + 0
		expect_error(rs1alt <- join_cent_sums(rs1,rs0),NA)
		expect_equal(rs1,rs1alt,tolerance=1e-7)
	}
	# just hit code to make sure it runs
	for (max_ord in c(1L,2L,3L,6L)) {
		for (narm in c(FALSE,TRUE)) {
			for (cw in c(FALSE,TRUE)) {
				for (nw in c(FALSE,TRUE)) {
					expect_error(rs1 <- cent_sums(x1,max_ord,wts=w1,na_rm=narm,
																				check_wts=cw,normalize_wts=nw),NA)
					expect_equal(length(rs1),max_ord+1)
				}
			}
		}
	}

})#UNFOLD
test_that("join commutativity",{#FOLDUP
	set.char.seed("f33946b3-216e-4977-9535-447b55214197")

	for (max_ord in c(1L,2L,3L,6L)) {
		x1 <- rnorm(1e3,mean=1)
		x2 <- rnorm(1e3,mean=1)
		expect_error(rs1 <- cent_sums(x1,max_ord),NA)
		expect_error(rs2 <- cent_sums(x2,max_ord),NA)
		expect_error(rs3_a <- join_cent_sums(rs1,rs2),NA)
		expect_error(rs3_b <- join_cent_sums(rs2,rs1),NA)
		expect_equal(rs3_a,rs3_b,tolerance=1e-7)

		# on an empty
		x1 <- c()
		x2 <- rnorm(1e3,mean=1)
		expect_error(rs1 <- cent_sums(x1,max_ord),NA)
		expect_error(rs2 <- cent_sums(x2,max_ord),NA)
		expect_error(rs3_a <- join_cent_sums(rs1,rs2),NA)
		expect_error(rs3_b <- join_cent_sums(rs2,rs1),NA)
		expect_equal(rs3_a,rs3_b,tolerance=1e-7)
	}

	# should this be an error?
	#rs1[1] <- -1
	#expect_error(rs3_a <- join_cent_sums(rs1,rs2))
	#expect_error(rs3_b <- join_cent_sums(rs2,rs1))
})#UNFOLD
context("monoid cosum")
test_that("cosums are sane",{#FOLDUP
	set.char.seed("0020a8c0-ff6a-447c-a9bf-c6cc7160195f")

	x1 <- matrix(rnorm(1e3*5,mean=1),ncol=5)
	max_ord <- 2L
	expect_error(rs1 <- cent_comoments(x1,max_ord,used_df=1L),NA)
	expect_equal(rs1[1,1],nrow(x1))
	expect_equal(rs1[1,1 + (1:ncol(x1))],colMeans(x1),tolerance=1e-7)
	expect_equal(rs1[1 + (1:ncol(x1)),1],colMeans(x1),tolerance=1e-7)
	expect_equal(rs1[1 + (1:ncol(x1)),1 + (1:ncol(x1))],cov(x1),tolerance=1e-7)
})#UNFOLD
test_that("cosums and na_omit ",{#FOLDUP
	set.char.seed("9b87264c-e543-44ed-b4df-7e70cfbaf59c")

	x1 <- matrix(rnorm(1e2*5,mean=1),ncol=5)
	x1[1,1] <- NA
	x2 <- x1[2:nrow(x1),,drop=FALSE]

	max_ord <- 2L
	expect_error(rs1 <- cent_comoments(x1,max_ord,used_df=1L,na_omit=TRUE),NA)
	expect_error(rs2 <- cent_comoments(x2,max_ord,used_df=1L,na_omit=TRUE),NA)
	expect_equal(rs1,rs2)
})#UNFOLD
context("monoid join/unjoin cosums")
test_that("join/unjoin cosums",{#FOLDUP
	set.char.seed("9ecdda29-aaae-4f88-9fe7-4418846ca54c")

	x1 <- matrix(rnorm(1e3*5,mean=1),ncol=5)
	x2 <- matrix(rnorm(1e3*5,mean=1),ncol=5)
	max_ord <- 2L
	expect_error(rs1 <- cent_cosums(x1,max_ord),NA)
	expect_error(rs2 <- cent_cosums(x2,max_ord),NA)
	expect_error(rs3 <- cent_cosums(rbind(x1,x2),max_ord),NA)
	expect_error(rs3alt <- join_cent_cosums(rs1,rs2),NA)
	expect_equal(rs3,rs3alt,tolerance=1e-7)

	expect_error(rs1alt <- unjoin_cent_cosums(rs3,rs2),NA)
	expect_error(rs2alt <- unjoin_cent_cosums(rs3,rs1),NA)
	expect_equal(rs1,rs1alt,tolerance=1e-7)
	expect_equal(rs2,rs2alt,tolerance=1e-7)
})#UNFOLD
test_that("commutativity of join cosums",{#FOLDUP
	max_ord <- 2L

	set.char.seed("eb9064dc-9463-4a2a-b824-ec33defed3b6")
	x1 <- matrix(rnorm(1e3*5,mean=1),ncol=5)
	x2 <- matrix(rnorm(1e3*5,mean=1),ncol=5)
	expect_error(rs1 <- cent_cosums(x1,max_ord),NA)
	expect_error(rs2 <- cent_cosums(x2,max_ord),NA)

	expect_error(rs3_a <- join_cent_cosums(rs1,rs2),NA)
	expect_error(rs3_b <- join_cent_cosums(rs2,rs1),NA)
	expect_equal(rs3_a,rs3_b,tolerance=1e-7)

})#UNFOLD

# 2FIX: check the effects of NA

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.31
# Copyright: Steven E. Pav, 2016-2016
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
THOROUGHNESS <- getOption('test.thoroughness',1.0)
#UNFOLD

context("code runs at all")#FOLDUP
test_that("constructor and such",{#FOLDUP
	set.char.seed("33c133f6-930f-4656-88d4-84493784eee3")

	x <- rnorm(100)
	expect_error(csums <- cent_sums(x, max_order=5L, na_rm=TRUE),NA)
	expect_error(xobj <- centsums(csums),NA)

	foo <- sums(xobj)
	for (type in c('central','raw','standardized')) {
		moms <- moments(xobj,type=type)
	}
	expect_error(capture_output(show(xobj)),NA)

	expect_error(xobj <- as.centsums(x,order=5L, na.rm=TRUE),NA)
})#UNFOLD
test_that("cosum constructor and such",{#FOLDUP
	set.char.seed("817d965f-c3fb-439b-92ef-8c42452688ea")

	x <- matrix(rnorm(30*3),ncol=3)
	expect_error(csums <- cent_cosums(x, max_order=2L, na_omit=TRUE),NA)
	expect_error(xobj <- centcosums(csums),NA)

	foo <- cosums(xobj)
	for (type in c('central','raw')) {
		expect_error(moms <- comoments(xobj,type=type),NA)
	}
	expect_error(capture_output(show(xobj)),NA)

	expect_error(xobj <- as.centcosums(x,order=2L, na.omit=TRUE),NA)
})#UNFOLD
# 2FIX: check the effects of NA
#UNFOLD
context("correctness")#FOLDUP
test_that("monoidal homomorphism",{#FOLDUP
	set.char.seed("3fb6ab54-f5b9-4965-8a76-477dd62d6d7e")

	x <- rnorm(100)
	y <- rnorm(100)
	order <- 5L
	expect_error(xobj <- as.centsums(x,order=order, na.rm=TRUE),NA)
	expect_error(yobj <- as.centsums(y,order=order, na.rm=TRUE),NA)
	expect_error(zobj <- as.centsums(c(x,y),order=order, na.rm=TRUE),NA)

	zalt <- c(xobj,yobj)
	expect_equal(sums(zalt),sums(zobj),tolerance=1e-9)

	expect_error(xalt <- zobj %-% yobj,NA)
	expect_error(yalt <- zobj %-% xobj,NA)
	expect_equal(sums(xalt),sums(xobj),tolerance=1e-9)
	expect_equal(sums(yalt),sums(yobj),tolerance=1e-9)
})#UNFOLD
test_that("cosums monoidal homomorphism",{#FOLDUP
	set.char.seed("68d7b935-7d0d-42a5-91e0-2ae711d92b35")

	x <- matrix(rnorm(100*4),ncol=4)
	y <- matrix(rnorm(100*4),ncol=4)
	order <- 2L
	expect_error(xobj <- as.centcosums(x,order=order, na.omit=TRUE),NA)
	expect_error(yobj <- as.centcosums(y,order=order, na.omit=TRUE),NA)
	expect_error(zobj <- as.centcosums(rbind(x,y),order=order, na.omit=TRUE),NA)

	zalt <- c(xobj,yobj)
	expect_equal(cosums(zalt),cosums(zobj),tolerance=1e-9)

	expect_error(xalt <- zobj %-% yobj,NA)
	expect_error(yalt <- zobj %-% xobj,NA)
	expect_equal(cosums(xalt),cosums(xobj),tolerance=1e-9)
	expect_equal(cosums(yalt),cosums(yobj),tolerance=1e-9)
})#UNFOLD
test_that("cosums make zero?",{#FOLDUP
	set.char.seed("5fbdb6e1-64ee-48dd-9131-98c66cfd1486")

	x <- matrix(rnorm(100*4),ncol=4)
	y <- matrix(rnorm(100*4),ncol=4)
	order <- 2L
	expect_error(xobj <- as.centcosums(x,order=order, na.omit=TRUE),NA)
	expect_error(yobj <- as.centcosums(y,order=order, na.omit=TRUE),NA)
	# x - x = 0
	expect_error(allz <- xobj %-% xobj,NA)
	expect_true(all(cosums(allz)==0))

	# x + 0 = x
	# 0 + y = y
	xalt <- c(xobj,allz)
	yalt <- c(allz,yobj)
	expect_equal(cosums(xalt),cosums(xobj),tolerance=1e-9)
	expect_equal(cosums(yalt),cosums(yobj),tolerance=1e-9)
})#UNFOLD
test_that("cosums bad input?",{#FOLDUP
	set.char.seed("6e06ef0e-fb0e-4adb-b27d-028db8028f20")

	x <- matrix(rnorm(100*4),ncol=4)
	y <- matrix(rnorm(100*6),ncol=6)

	order <- 2L
	expect_error(xobj <- as.centcosums(x,order=order, na.omit=TRUE),NA)
	expect_error(yobj <- as.centcosums(y,order=order, na.omit=TRUE),NA)

	# these should all be erorrs??
	#expect_error(c(xobj,yobj))
	#expect_error(xobj %-% yobj)
})#UNFOLD


# 2FIX: check the effects of NA
#UNFOLD

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2019.01.15
# Copyright: Steven E. Pav, 2016-2019
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
#UNFOLD

# code runs at all
context("code runs: t_running_sd etc")
test_that("t_running sd, skew, kurt run without error",{#FOLDUP
	skip_on_cran()

	set.char.seed("1cfb2b84-7eae-42f6-90ad-2552e74a5ad0")
	x <- rnorm(100)
	times <- seq_along(x)
	y <- as.integer(x)
	z <- as.logical(y)
	q <- c('a','b','c')

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)

	for (thingy in list(x,y,z)) { 
		for (window in c(50,Inf)) {
			for (na_rm in c(FALSE,TRUE)) {
				expect_error(t_running_sum(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_mean(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_sd(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_skew(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_kurt(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_sd3(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_skew4(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_kurt5(thingy,time=times,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_cent_moments(thingy,time=times,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_cent_moments(thingy,time=times,max_order=5L,window=window,restart_period=50L,na_rm=na_rm,max_order_only=TRUE),NA)
				expect_error(t_running_std_moments(thingy,time=times,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_cumulants(thingy,time=times,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(t_running_apx_quantiles(thingy,time=times,p=ptiles,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
			}
		}
	}

	for (thingy in list(x,y,z)) { 
		for (min_df in c(2L,10L)) {
			expect_error(t_running_sum(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_mean(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_sd(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_skew(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_kurt(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_sd3(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_skew4(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_kurt5(thingy,time=times,window=window,min_df=min_df),NA)
			expect_error(t_running_cent_moments(thingy,time=times,max_order=5L,window=window,min_df=min_df),NA)
			expect_error(t_running_cent_moments(thingy,time=times,max_order=5L,window=window,min_df=min_df,max_order_only=TRUE),NA)
			expect_error(t_running_std_moments(thingy,time=times,max_order=5L,window=window,min_df=min_df),NA)
			expect_error(t_running_cumulants(thingy,time=times,max_order=5L,window=window,min_df=min_df),NA)
			expect_error(t_running_apx_quantiles(thingy,time=times,p=ptiles,max_order=5L,window=window,min_df=min_df),NA)
		}
	}


	expect_error(t_running_sum(q))
	expect_error(t_running_mean(q))
	expect_error(t_running_sd(q))
	expect_error(t_running_skew(q))
	expect_error(t_running_kurt(q))
	expect_error(t_running_sd3(q))
	expect_error(t_running_skew4(q))
	expect_error(t_running_kurt5(q))
	expect_error(t_running_cent_moments(q,max_order=5L))
	expect_error(t_running_cent_moments(q,max_order=5L,max_order_only=TRUE))
	expect_error(t_running_std_moments(q,max_order=5L))
	expect_error(t_running_cumulants(q,max_order=5L))
	expect_error(t_running_apx_quantiles(q,p=ptiles,max_order=5L))
	#expect_error(t_running_apx_quantiles(x,p=q,max_order=5L))
	expect_error(t_running_apx_median(q,p=ptiles,max_order=5L))
})#UNFOLD

context("code runs: t_running_foo and weights")
test_that("t_running foo and weights",{#FOLDUP
	skip_on_cran()

	set.char.seed("95aa6ed1-14dc-473a-a7aa-8dc9869b1dbc")
	nel <- 30

	xna <- rnorm(2*nel)
	xna[xna < 0] <- NA

	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	rp <- 5L

	for (thingy in xall) {
		for (times in list(NULL,cumsum(runif(length(thingy),min=0.2,max=0.4)))) {
			wna <- runif(length(thingy),min=1.0,max=3.0)
			wna[wna < 1.4] <- NA
			wall <- list(rep(1.0,length(thingy)),
									 runif(length(thingy),min=0.9,max=3.5),
									 wna,
									 NULL)
			for (wts in wall) {
				wts_as_delta <- is.null(times) & !is.null(wts)
				can_test <- (!wts_as_delta || is.null(wts) || !any(is.na(wts))) && (!is.null(times) || wts_as_delta)
				if (can_test) { 
					for (window in c(5.5,21.23,Inf,NULL)) {
						for (na_rm in c(FALSE,TRUE)) {
							for (lb_time in list(NULL,3+cumsum(runif(10,min=0.4,max=1.1)))) {
								expect_error(t_running_sum(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_mean(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_sd(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_skew(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_kurt(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_sd3(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_skew4(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_kurt5(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_cent_moments(thingy,time=times,wts=wts,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_cent_moments(thingy,time=times,wts=wts,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,max_order_only=TRUE),NA)
								expect_error(t_running_std_moments(thingy,time=times,wts=wts,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_cumulants(thingy,time=times,wts=wts,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_apx_quantiles(thingy,time=times,wts=wts,p=ptiles,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_apx_median(thingy,time=times,wts=wts,max_order=5L,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_sharpe(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
								expect_error(t_running_sharpe(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,compute_se=TRUE),NA)
								expect_error(t_running_tstat(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)

								# NOTA BENE: these three do not accept an lb_time b/c they are associated with the thingy;
								# so we *do* expect these to error.
								expect_error(t_running_centered(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
								expect_error(t_running_scaled(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
								expect_error(t_running_zscored(thingy,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
							}

							for (lookahead in c(0,8.3)) {
								expect_error(t_running_centered(thingy,time=times,wts=wts,window=window,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
								expect_error(t_running_scaled(thingy,time=times,wts=wts,window=window,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
								expect_error(t_running_zscored(thingy,time=times,wts=wts,window=window,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
							}
						}
					}
				}
			}
		}
	}

})#UNFOLD
test_that("t_running foo logical weights",{# FOLDUP
	skip_on_cran()

	set.char.seed("422008f4-5782-4f01-a357-5b254a16660e")
	nel <- 30

	xna <- rnorm(2*nel)
	xna[xna < 0] <- NA

	rp <- 5L
	times <- cumsum(runif(length(xna),min=0.5,max=1.5))
	window <- 17.5
	na_rm <- TRUE
	lb_time <- NULL
	wts <- rnorm(length(xna)) > 0
	expect_error(t_running_sum(xna,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=FALSE,restart_period=rp,na_rm=na_rm),NA)
	expect_error(t_running_mean(xna,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=FALSE,restart_period=rp,na_rm=na_rm),NA)
	expect_error(t_running_sd(xna,time=times,wts=wts,window=window,lb_time=lb_time,wts_as_delta=FALSE,restart_period=rp,na_rm=na_rm),NA)

})# UNFOLD
context("code runs: t_running_foo NA weights")
test_that("t_running foo  NA weights",{#FOLDUP
	skip_on_cran()

	set.char.seed("82da516f-6185-4f65-8576-f8c02e00d61e")
	nel <- 25

	xall <- list(rnorm(nel))

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	rp <- 5L
	wts_as_delta <- FALSE

	for (thingy in xall) {
		wts <- runif(length(thingy),min=0.9,max=1.2)
		wts[wts < 1] <- NA
		for (times in list(cumsum(runif(length(thingy),min=0.2,max=0.4)))) {
			for (na_rm in c(FALSE,TRUE)) {
				for (lb_time in list(max(times) + c(1:2),3+cumsum(runif(10,min=0.4,max=1.1)))) {
					expect_error(t_running_sum(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_mean(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_sd(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_skew(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_kurt(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_sd3(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_skew4(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_kurt5(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_cent_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_cent_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,max_order_only=TRUE),NA)
					expect_error(t_running_std_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_cumulants(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_apx_quantiles(thingy,time=times,wts=wts,variable_win=TRUE,p=ptiles,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_apx_median(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_sharpe(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
					expect_error(t_running_sharpe(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,compute_se=TRUE),NA)
					expect_error(t_running_tstat(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)

					# NOTA BENE: these three do not accept an lb_time b/c they are associated with the thingy;
					# so we *do* expect these to error.
					expect_error(t_running_centered(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
					expect_error(t_running_scaled(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
					expect_error(t_running_zscored(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
				}

				for (lookahead in c(0,8.3)) {
					expect_error(t_running_centered(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
					expect_error(t_running_scaled(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
					expect_error(t_running_zscored(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
				}
			}
		}
	}

})#UNFOLD
context("code runs: t_running_foo odds and ends")
test_that("t_running foo  variable_win",{#FOLDUP
	skip_on_cran()

	set.char.seed("6e33dc8f-7a0b-4128-956f-f9ac960549ee")
	nel <- 25

	xna <- rnorm(2*nel)
	xna[xna < 0] <- NA

	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	rp <- 5L
	wts_as_delta <- FALSE

	for (thingy in xall) {
		for (times in list(cumsum(runif(length(thingy),min=0.2,max=0.4)))) {
			wall <- list(rep(1.0,length(thingy)), NULL)
			for (wts in wall) {
				for (na_rm in c(FALSE,TRUE)) {
					for (lb_time in list(max(times) + c(1:2),3+cumsum(runif(10,min=0.4,max=1.1)))) {
						expect_error(t_running_sum(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_mean(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_sd(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_skew(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_kurt(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_sd3(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_skew4(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_kurt5(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_cent_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_cent_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,max_order_only=TRUE),NA)
						expect_error(t_running_std_moments(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_cumulants(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_apx_quantiles(thingy,time=times,wts=wts,variable_win=TRUE,p=ptiles,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_apx_median(thingy,time=times,wts=wts,variable_win=TRUE,max_order=5L,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_sharpe(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_sharpe(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm,compute_se=TRUE),NA)
						expect_error(t_running_tstat(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)

						# NOTA BENE: these three do not accept an lb_time b/c they are associated with the thingy;
						# so we *do* expect these to error.
						expect_error(t_running_centered(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
						expect_error(t_running_scaled(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
						expect_error(t_running_zscored(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm))
					}

					for (lookahead in c(0,8.3)) {
						expect_error(t_running_centered(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
						expect_error(t_running_scaled(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
						expect_error(t_running_zscored(thingy,time=times,wts=wts,variable_win=TRUE,wts_as_delta=wts_as_delta,restart_period=rp,lookahead=lookahead,na_rm=na_rm),NA)
					}
				}
			}
		}
	}


})#UNFOLD
test_that("t_running foo  infinite recompute",{#FOLDUP
	skip_on_cran()

	set.char.seed("b3efd3a7-9a46-4d37-b6a1-d864a5f9a0f0")
	nel <- 25

	xna <- rnorm(2*nel)
	xna[xna < 0] <- NA

	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	rp <- 5L
	wts_as_delta <- FALSE

	for (thingy in xall) {
		for (times in list(cumsum(runif(length(thingy),min=0.2,max=0.4)))) {
			wall <- list(rep(1.0,length(thingy)), NULL)
			for (wts in wall) {
				for (na_rm in c(FALSE,TRUE)) {
					for (lb_time in list(max(times) + c(1:2),3+cumsum(runif(10,min=0.4,max=1.1)))) {
						expect_error(vers1 <- t_running_sd(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=rp,na_rm=na_rm),NA)
						expect_error(vers2 <- t_running_sd(thingy,time=times,wts=wts,variable_win=TRUE,lb_time=lb_time,wts_as_delta=wts_as_delta,restart_period=NA_integer_,na_rm=na_rm),NA)
						expect_equal(vers1,vers2)
					}
				}
			}
		}
	}


})#UNFOLD

context("t_running foo input params")
test_that("window as integer or double",{#FOLDUP
	skip_on_cran()

	set.char.seed("c0b02fb4-cd35-4403-8a13-950b5f2236f2")
	nel <- 40
	thingy <- rnorm(nel)
	times <- seq_along(thingy)
	iwin <- 50L
	dwin <- as.numeric(iwin)
	charwin <- 'window'

	expect_error(rd <- t_running_sum(thingy,time=times,window=dwin),NA)
	expect_error(ri <- t_running_sum(thingy,time=times,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(t_running_sum(thingy,times=times,window=charwin))
	
	expect_error(rd <- t_running_mean(thingy,time=times,window=dwin),NA)
	expect_error(ri <- t_running_mean(thingy,time=times,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(t_running_mean(thingy,times=times,window=charwin))

	expect_error(rd <- t_running_sd(thingy,time=times,window=dwin),NA)
	expect_error(ri <- t_running_sd(thingy,time=times,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(t_running_sd(thingy,times=times,window=charwin))

	expect_error(rd <- t_running_skew(thingy,time=times,window=dwin),NA)
	expect_error(ri <- t_running_skew(thingy,time=times,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(t_running_skew(thingy,times=times,window=charwin))

	expect_error(rd <- t_running_kurt(thingy,time=times,window=dwin),NA)
	expect_error(ri <- t_running_kurt(thingy,time=times,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(t_running_kurt(thingy,times=times,window=charwin))


})#UNFOLD
context("trunning_foo check heywood cases")
test_that("hit heywood branch",{#FOLDUP
	skip_on_cran()
	# not sure what I had planned here, and how it tests for heywoods.
	set.char.seed("3d318f1d-9921-4a20-84fc-c5ffc722d52c")
	xvals <- list(rnorm(1e5,mean=1e10))
	x <- rnorm(1e4)
	x[x < 1.0] <- NA
	xvals[[length(xvals)+1]] <- x
	x <- rnorm(1e4)
	x[x < 1.5] <- NA
	xvals[[length(xvals)+1]] <- x

	for (x in xvals) {
		window <- 500
		restart_period <- 100000L
		na_rm <- TRUE
		times <- seq_along(x)

		expect_error(y <- t_running_sd3(x,time=times,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- y[window:nrow(y),1]
		expect_false(any(ys < 0 | is.na(ys)))

		expect_error(y <- t_running_skew4(x,time=times,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- y[window:nrow(y),2]
		expect_false(any(ys < 0 | is.na(ys)))

		expect_error(y <- t_running_kurt5(x,time=times,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- 3 + y[window:nrow(y),1]
		expect_false(any(ys < 0 | is.na(ys)))
		ys <- y[window:nrow(y),3]
		expect_false(any(ys < 0 | is.na(ys)))
		# not sure where I would expect Heywoods in the other ones.
	}
})#UNFOLD

context("running x y code")
test_that("runs without error",{#FOLDUP
	skip_on_cran()

	set.char.seed("c13a49ac-14e9-462b-b81e-d3a5fc3be491")
	nel <- 20
	xna <- rnorm(nel)
	xna[xna < -0.5] <- NA
	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	wna <- runif(nel,min=1,max=3)
	wna[wna < 1.5] <- NA
	wall <- list(rep(1.0,nel),
							 runif(nel,min=0.9,max=3.5),
							 wna,
							 as.integer(ceiling(runif(nel,min=2,max=100))),
							 as.logical(ceiling(pmax(0,rnorm(nel)))),
							 NULL)

	for (x_thingy in xall) {
		y_thingy <- x_thingy + 1
		for (wts in wall) {
			for (window in c(5,21,Inf,NULL)) {
				for (na_rm in c(FALSE,TRUE)) {
					for (rp in c(1L,40L)) {
						times <- seq_along(x_thingy)
						expect_error(t_running_correlation(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_covariance(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_covariance_3(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_regression_slope(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_regression_intercept(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_regression_fit(x_thingy,y_thingy,wts=wts,time=times,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(t_running_regression_diagnostics(x_thingy,y_thingy,time=times,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
					}
				}
			}
		}
	}
})#UNFOLD
test_that("covariance correctness",{#FOLDUP
	skip_on_cran()

	set.char.seed("b81052f6-d7a5-4f3f-95cf-bc8d0030fcf8")
	window <- 30
	maxplus <- 50
	nel <- window + maxplus
	xvec <- rnorm(nel)
	beta_0 <- 0.33
	beta_1 <- 5
	sigma <- 0.5
	yvec <- beta_0 + beta_1 * xvec + rnorm(length(xvec),sd=sigma)
	times <- seq_along(xvec)
	expect_error(rho <- t_running_correlation(xvec,yvec,time=times,window=window-0.5),NA)
	expect_equal(rho[window], cor(xvec[1:window],yvec[1:window]), tolerance=1e-12)
	expect_equal(rho[1+window], cor(xvec[2:(1+window)],yvec[2:(1+window)]), tolerance=1e-12)

	expect_error(rho <- t_running_covariance(xvec,yvec,time=times,window=window-0.5,used_df=1),NA)
	expect_equal(rho[window], cov(xvec[1:window],yvec[1:window]), tolerance=1e-12)
	expect_equal(rho[1+window], cov(xvec[2:(1+window)],yvec[2:(1+window)]), tolerance=1e-12)

	expect_error(beta_1 <- t_running_regression_slope(xvec,yvec,time=times,window=window),NA)
	expect_error(beta_0 <- t_running_regression_intercept(xvec,yvec,time=times,window=window),NA)
	mod0 <- lm(yvec[1:window] ~ xvec[1:window])
	ses <- sqrt(diag(vcov(mod0)))

	expect_equal(beta_0[window], coefficients(mod0)[[1]], tolerance=1e-12)
	expect_equal(beta_1[window], coefficients(mod0)[[2]], tolerance=1e-12)
	expect_error(beta_ff <- t_running_regression_fit(xvec,yvec,time=times,window=window),NA)
	expect_equal(beta_ff[,1,drop=FALSE], beta_0, tolerance=1e-12)
	expect_equal(beta_ff[,2,drop=FALSE], beta_1, tolerance=1e-12)
	expect_error(beta_dd <- t_running_regression_diagnostics(xvec,yvec,time=times,window=window),NA)
	expect_equal(beta_dd[,1,drop=FALSE], beta_0, tolerance=1e-12)
	expect_equal(beta_dd[,2,drop=FALSE], beta_1, tolerance=1e-12)
	# also compare against diag(vcov(mod0))
	expect_equal(beta_dd[window,3], summary(mod0)$sigma, tolerance=1e-12)
	expect_equal(beta_dd[window,4], as.numeric(ses[1]), tolerance=1e-12)
	expect_equal(beta_dd[window,5], as.numeric(ses[2]), tolerance=1e-12)

	# and a little bit forward
	for (offs in c(5, maxplus - 1)) {
		mod1 <- lm(yvec[offs + (1:window)] ~ xvec[offs + (1:window)])
		ses <- sqrt(diag(vcov(mod1)))
		expect_equal(beta_0[offs+window], coefficients(mod1)[[1]], tolerance=1e-12)
		expect_equal(beta_1[offs+window], coefficients(mod1)[[2]], tolerance=1e-12)
		expect_equal(beta_dd[offs+window,3], summary(mod1)$sigma, tolerance=1e-12)
		expect_equal(beta_dd[offs+window,4], as.numeric(ses[1]), tolerance=1e-12)
		expect_equal(beta_dd[offs+window,5], as.numeric(ses[2]), tolerance=1e-12)
	}
})#UNFOLD
test_that("compare to running",{#FOLDUP
	# the idea here is that 
	skip_on_cran()

	set.char.seed("b81052f6-d7a5-4f3f-95cf-bc8d0030fcf8")
	window <- 30
	maxplus <- 50
	nel <- window + maxplus
	xvec <- rnorm(nel)
	beta_0 <- 0.33
	beta_1 <- 5
	sigma <- 0.5
	yvec <- beta_0 + beta_1 * xvec + rnorm(length(xvec),sd=sigma)
	times <- seq_along(xvec)
	expect_error(trho <- t_running_correlation(xvec,yvec,time=times,window=window),NA)
	expect_error(rho <- running_correlation(xvec,yvec,window=window,check_negative_moments=FALSE),NA)
	expect_equal(rho, trho, tolerance=1e-12)

	expect_error(tsxy <- t_running_covariance(xvec,yvec,time=times,window=window),NA)
	expect_error(sxy <- running_covariance(xvec,yvec,window=window,check_negative_moments=FALSE),NA)
	expect_equal(sxy, tsxy, tolerance=1e-12)

	expect_error(tbeta_0 <- t_running_regression_intercept(xvec,yvec,time=times,window=window),NA)
	expect_error(beta_0 <- running_regression_intercept(xvec,yvec,window=window,check_negative_moments=FALSE),NA)
	expect_equal(beta_0, tbeta_0, tolerance=1e-12)

	expect_error(tbeta_1 <- t_running_regression_slope(xvec,yvec,time=times,window=window),NA)
	expect_error(beta_1 <- running_regression_slope(xvec,yvec,window=window,check_negative_moments=FALSE),NA)
	expect_equal(beta_1, tbeta_1, tolerance=1e-12)

	expect_error(tbeta_dd <- t_running_regression_diagnostics(xvec,yvec,time=times,window=window),NA)
	expect_error(beta_dd <- running_regression_diagnostics(xvec,yvec,window=window,check_negative_moments=FALSE),NA)
	expect_equal(beta_dd, tbeta_dd, tolerance=1e-12)

})#UNFOLD
test_that("covariance weighting correctness",{#FOLDUP
	skip_on_cran()

	set.char.seed("f3d1652c-2d83-4670-998b-f96d18d18374")
	window <- 50
	nel <- window
	xvec <- rnorm(nel)
	beta_0 <- 0.33
	beta_1 <- 5
	sigma <- 0.5
	yvec <- beta_0 + beta_1 * xvec + rnorm(length(xvec),sd=sigma)
	wts <- sample(c(1,2,3),nel,replace=TRUE)
	times <- seq_along(xvec)
	expect_error(rho <- t_running_correlation(xvec,yvec,time=times,window=window,wts=wts),NA)
	bigx <- rep(xvec,wts)
	bigy <- rep(yvec,wts)
	bigtimes <- seq_along(bigx)
	expect_error(rho2 <- t_running_correlation(bigx,bigy,time=bigtimes,window=length(bigx)),NA)
	expect_equal(rho[window],rho2[length(rho2)], tolerance=1e-12)

	expect_error(rho <- t_running_covariance(xvec,yvec,time=times,wts=wts,window=window,normalize_wts=FALSE,used_df=1),NA)
	expect_error(rho2 <- t_running_covariance(bigx,bigy,time=bigtimes,window=length(bigx),used_df=1),NA)
	expect_equal(rho[window],rho2[length(rho2)], tolerance=1e-12)

	expect_error(beta_0 <- t_running_regression_intercept(xvec,yvec,time=times,wts=wts,window=window),NA)
	expect_error(beta_1 <- t_running_regression_slope(xvec,yvec,time=times,wts=wts,window=window),NA)
	expect_error(beta_02 <- t_running_regression_intercept(bigx,bigy,time=bigtimes,window=length(bigx)),NA)
	expect_error(beta_12 <- t_running_regression_slope(bigx,bigy,time=bigtimes,window=length(bigx)),NA)
	expect_equal(beta_0[window],beta_02[length(bigx)], tolerance=1e-12)
	expect_equal(beta_1[window],beta_12[length(bigx)], tolerance=1e-12)

	expect_error(beta_dd <- t_running_regression_diagnostics(xvec,yvec,time=times,wts=wts,window=window,normalize_wts=FALSE),NA)
	expect_error(beta_dd2 <- t_running_regression_diagnostics(bigx,bigy,time=bigtimes,window=length(bigx)),NA)
	expect_equal(beta_dd[window,,drop=TRUE],beta_dd2[length(bigx),,drop=TRUE], tolerance=1e-12)
})#UNFOLD

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:

# Copyright 2016 Steven E. Pav. All Rights Reserved.
# Author: Steven E. Pav

# This file is part of fromo.
#
# fromo is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# fromo is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with fromo.  If not, see <http://www.gnu.org/licenses/>.

# env var:
# nb: 
# see also:
# todo:
# changelog: 
#
# Created: 2016.03.25
# Copyright: Steven E. Pav, 2016-2019
# Author: Steven E. Pav
# Comments: Steven E. Pav

# helpers#FOLDUP
set.char.seed <- function(str) {
	set.seed(as.integer(charToRaw(str)))
}
#UNFOLD

context("running_foo run without error")
test_that("running sd, skew, kurt run without error",{#FOLDUP
	skip_on_cran()

	set.char.seed("7097f6ae-eac7-4e3a-b2cc-e9d4a01d43f7")
	x <- rnorm(100)
	y <- as.integer(x)
	z <- as.logical(y)
	q <- c('a','b','c')

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)

	for (thingy in list(x,y,z)) { 
		for (window in c(50,Inf)) {
			for (na_rm in c(FALSE,TRUE)) {
				expect_error(running_sum(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_mean(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_sd(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_skew(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_kurt(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_sd3(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_skew4(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_kurt5(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				for (mol in c(1L,2L,5L)) {
					expect_error(running_cent_moments(thingy,max_order=mol,window=window,restart_period=50L,na_rm=na_rm),NA)
					expect_error(running_cent_moments(thingy,max_order=mol,window=window,restart_period=50L,na_rm=na_rm,max_order_only=TRUE),NA)
				}
				expect_error(running_std_moments(thingy,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_cumulants(thingy,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_apx_quantiles(thingy,p=ptiles,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
			}
		}
	}
	for (thingy in list(x,y,z)) { 
		for (min_df in c(2L,10L)) {
			expect_error(running_mean(thingy,window=window,min_df=min_df),NA)
			expect_error(running_sd(thingy,window=window,min_df=min_df),NA)
			expect_error(running_skew(thingy,window=window,min_df=min_df),NA)
			expect_error(running_kurt(thingy,window=window,min_df=min_df),NA)
			expect_error(running_sd3(thingy,window=window,min_df=min_df),NA)
			expect_error(running_skew4(thingy,window=window,min_df=min_df),NA)
			expect_error(running_kurt5(thingy,window=window,min_df=min_df),NA)
			for (mol in c(1L,2L,5L)) {
				expect_error(running_cent_moments(thingy,max_order=mol,window=window,min_df=min_df),NA)
				expect_error(running_cent_moments(thingy,max_order=mol,window=window,min_df=min_df,max_order_only=TRUE),NA)
			}
			expect_error(running_std_moments(thingy,max_order=5L,window=window,min_df=min_df),NA)
			expect_error(running_cumulants(thingy,max_order=5L,window=window,min_df=min_df),NA)
			expect_error(running_apx_quantiles(thingy,p=ptiles,max_order=5L,window=window,min_df=min_df),NA)
		}
	}

	# will not work on character input
	expect_error(running_sum(q))
	expect_error(running_mean(q))
	expect_error(running_sd(q))
	expect_error(running_skew(q))
	expect_error(running_kurt(q))
	expect_error(running_sd3(q))
	expect_error(running_skew4(q))
	expect_error(running_kurt5(q))
	expect_error(running_cent_moments(q,max_order=5L))
	expect_error(running_cent_moments(q,max_order=5L,max_order_only=TRUE))
	expect_error(running_std_moments(q,max_order=5L))
	expect_error(running_cumulants(q,max_order=5L))
	expect_error(running_apx_quantiles(q,p=ptiles,max_order=5L))
	# this crashes R when I run it:
	#expect_error(running_apx_quantiles(x,p=q,max_order=5L))
	expect_error(running_apx_median(q,p=ptiles,max_order=5L))
})#UNFOLD
context("running_foo weighted OK")
test_that("running foo and weights",{#FOLDUP
	skip_on_cran()

	set.char.seed("7097f6ae-eac7-4e3a-b2cc-e9d4a01d43f7")
	nel <- 20
	xna <- rnorm(nel)
	xna[xna < -0.5] <- NA
	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	wna <- runif(nel,min=1,max=3)
	wna[wna < 1.5] <- NA
	wall <- list(rep(1.0,nel),
							 runif(nel,min=0.9,max=3.5),
							 wna,
							 NULL)

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)

	for (thingy in xall) {
		for (wts in wall) {
			for (window in c(5,21,Inf,NULL)) {
				for (na_rm in c(FALSE,TRUE)) {
						expect_error(running_sum(thingy,wts=wts,window=window,restart_period=2L,na_rm=na_rm),NA)

						expect_error(running_sum(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_mean(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_sd(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_skew(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_kurt(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_sd3(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_skew4(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_kurt5(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						for (mol in c(1L,2L,5L)) {
							expect_error(running_cent_moments(thingy,wts=wts,max_order=mol,window=window,restart_period=50L,na_rm=na_rm),NA)
							expect_error(running_cent_moments(thingy,wts=wts,max_order=mol,window=window,restart_period=50L,na_rm=na_rm,max_order_only=TRUE),NA)
						}
						expect_error(running_std_moments(thingy,wts=wts,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_cumulants(thingy,wts=wts,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_apx_quantiles(thingy,wts=wts,p=ptiles,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_apx_median(thingy,wts=wts,max_order=5L,window=window,restart_period=50L,na_rm=na_rm),NA)

						#expect_error(running_centered(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)

						for (lookahead in c(0L,8L)) {
							expect_error(running_centered(thingy,wts=wts,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
							expect_error(running_scaled(thingy,wts=wts,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
							expect_error(running_zscored(thingy,wts=wts,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
						}
						expect_error(running_sharpe(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
						expect_error(running_sharpe(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm,compute_se=TRUE),NA)
						expect_error(running_tstat(thingy,wts=wts,window=window,restart_period=50L,na_rm=na_rm),NA)
				}
			}
		}
	}


})#UNFOLD

context("running_sum every way")
test_that("running sum",{#FOLDUP
	skip_on_cran()

	set.char.seed("20c032c9-deb2-4000-9d73-b7d8395b67b2")
	nel <- 20
	xna <- rnorm(nel)
	xna[xna < -0.5] <- NA
	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	wna <- runif(nel,min=1,max=3)
	wna[wna < 1.5] <- NA
	wall <- list(rep(1.0,nel),
							 runif(nel,min=0.9,max=3.5),
							 wna,
							 as.integer(ceiling(runif(nel,min=2,max=100))),
							 as.logical(ceiling(pmax(0,rnorm(nel)))),
							 NULL)

	for (thingy in xall) {
		for (wts in wall) {
			for (window in c(5,21,Inf,NULL)) {
				for (na_rm in c(FALSE,TRUE)) {
					for (rp in c(1L,40L)) {
						expect_error(running_sum(thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
					}
				}
			}
		}
	}
})#UNFOLD
test_that("constant input",{#FOLDUP
	x <- rep(1,8)
	for (maxord in c(2,4,5)) {
		expect_error(yy <- running_cent_moments(x,window=6,max_order=maxord),NA)
		expect_true(!any(is.na(yy[nrow(yy),,drop=TRUE]) ))
	}
	expect_error(y3 <- running_sd3(x,window=5),NA)
	expect_true(!is.na(y3[nrow(y3),1,drop=TRUE]))
	expect_error(y4 <- running_skew4(x,window=5),NA)
	expect_true(!is.na(y4[nrow(y4),2,drop=TRUE]))
	expect_error(y5 <- running_kurt5(x,window=5),NA)
	expect_true(!is.na(y5[nrow(y5),3,drop=TRUE]))
	# if skewness is divided by stdev, there will be 0/0 condition here, 
	# so drop these
	# expect_error(y4 <- running_skew4(x,window=5),NA)
	# expect_true(!any(is.na(y4[nrow(y4),,drop=TRUE]) ))
	# expect_error(y5 <- running_kurt5(x,window=5),NA)
	# expect_true(!any(is.na(y5[nrow(y5),,drop=TRUE]) ))
})#UNFOLD

context("running foo input params")
test_that("window as integer or double",{#FOLDUP
	skip_on_cran()

	set.char.seed("da774aca-bbde-4350-87b2-d21ed0c84124")
	nel <- 40
	thingy <- rnorm(nel)
	iwin <- 50L
	dwin <- as.numeric(iwin)
	charwin <- 'window'

	expect_error(rd <- running_sum(thingy,window=dwin),NA)
	expect_error(ri <- running_sum(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_sum(thingy,window=charwin))

	expect_error(rd <- running_mean(thingy,window=dwin),NA)
	expect_error(ri <- running_mean(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_mean(thingy,window=charwin))

	expect_error(rd <- running_sd(thingy,window=dwin),NA)
	expect_error(ri <- running_sd(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_sd(thingy,window=charwin))

	expect_error(rd <- running_skew(thingy,window=dwin),NA)
	expect_error(ri <- running_skew(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_skew(thingy,window=charwin))

	expect_error(rd <- running_kurt(thingy,window=dwin),NA)
	expect_error(ri <- running_kurt(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_kurt(thingy,window=charwin))

	expect_error(rd <- running_sd3(thingy,window=dwin),NA)
	expect_error(ri <- running_sd3(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_sd3(thingy,window=charwin))

	expect_error(rd <- running_skew4(thingy,window=dwin),NA)
	expect_error(ri <- running_skew4(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_skew4(thingy,window=charwin))

	expect_error(rd <- running_kurt5(thingy,window=dwin),NA)
	expect_error(ri <- running_kurt5(thingy,window=iwin),NA)
	expect_equal(rd,ri,tolerance=1e-12)
	expect_error(running_kurt5(thingy,window=charwin))
})#UNFOLD
test_that("bad input",{#FOLDUP
	skip_on_cran()

	set.char.seed("e6bc7b67-8ba5-4c48-aeed-180a27d3303c")
	nel <- 10
	thingy <- rnorm(nel)
	# for some reason, these now cause R to abort? auuggggh!

	expect_error(rd <- running_sum(thingy,window='bad idea'))
	expect_error(rd <- running_mean(thingy,window=5,restart_period='dumb'))
	expect_error(rd <- running_mean(thingy,window=5,min_df='dumb'))
	expect_error(rd <- running_mean(thingy,window=5,na_rm='dumb'))
	expect_error(rd <- running_sd3(thingy,window=5,used_df='dumb'))
	expect_error(rd <- running_sd3(thingy,window=5,check_wts='dumb'))
	expect_error(rd <- running_sd3(thingy,window=5,normalize_wts='dumb'))
})#UNFOLD
context("running_foo check heywood cases")
test_that("hit heywood branch",{#FOLDUP
	skip_on_cran()

	# not sure what I had planned here, and how it tests for heywoods.
	ptiles <- c(0.1,0.25,0.5,0.75,0.9)
	set.char.seed("3d318f1d-9921-4a20-84fc-c5ffc722d52c")
	xvals <- list(rnorm(1e5,mean=1e10))
	x <- rnorm(1e4)
	x[x < 1.0] <- NA
	xvals[[length(xvals)+1]] <- x
	x <- rnorm(1e4)
	x[x < 1.5] <- NA
	xvals[[length(xvals)+1]] <- x

	for (x in xvals) {
		window <- 500L
		restart_period <- 100000L
		na_rm <- TRUE

		expect_error(y <- running_sd3(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- y[window:nrow(y),1]
		expect_false(any(ys < 0 | is.na(ys)))

		expect_error(y <- running_skew4(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- y[window:nrow(y),2]
		expect_false(any(ys < 0 | is.na(ys)))

		expect_error(y <- running_kurt5(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		ys <- 3 + y[window:nrow(y),1]
		expect_false(any(ys < 0 | is.na(ys)))
		ys <- y[window:nrow(y),3]
		expect_false(any(ys < 0 | is.na(ys)))

		# not sure where I would expect Heywoods in here.
		# expect_error(y <- running_cent_moments(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		# expect_error(running_cent_moments(x,max_order=5L,window=window,restart_period=restart_period,max_order_only=TRUE,na_rm=na_rm),NA)
		# expect_error(running_std_moments(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		# expect_error(running_cumulants(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		# expect_error(running_apx_quantiles(x,p=ptiles,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		# expect_error(running_apx_median(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
	}
})#UNFOLD
test_that("hit corner cases",{#FOLDUP
	# created with the intention of causing Heywoods
	epsi <- 1e-16
	xx <- c(1,1+epsi,epsi,1,1,1)
	expect_error(y <- fromo::running_sd3(xx,3,check_negative_moments=FALSE),NA)
	expect_true(is.nan(y[nrow(y),1]))
	expect_error(y <- fromo::running_sd3(xx,3,check_negative_moments=TRUE),NA)
	expect_false(is.nan(y[nrow(y),1]))
})#UNFOLD
context("running_foo: NA restart")
test_that("NA restart period?",{#FOLDUP
	skip_on_cran()

	ptiles <- c(0.1,0.25,0.5,0.75,0.9)

	set.char.seed("3d318f1d-9921-4a20-84fc-c5ffc722d52c")
	xvals <- list(rnorm(1e2,mean=1e10))
	x <- rnorm(1e3)
	x[x < 1.0] <- NA
	xvals[[length(xvals)+1]] <- x
	x <- rnorm(1e3)
	x[x < 1.5] <- NA
	xvals[[length(xvals)+1]] <- x

	for (x in xvals) {
		window <- 50L
		restart_period <- NA_integer_
		na_rm <- TRUE
		expect_error(running_sum(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_mean(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)

		expect_error(running_sd3(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_skew4(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_kurt5(x,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_cent_moments(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		for (mol in c(1L,2L,5L)) {
			expect_error(running_cent_moments(x,max_order=mol,window=window,restart_period=restart_period,max_order_only=TRUE,na_rm=na_rm),NA)
		}
		expect_error(running_std_moments(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_cumulants(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_apx_quantiles(x,p=ptiles,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)
		expect_error(running_apx_median(x,max_order=5L,window=window,restart_period=restart_period,na_rm=na_rm),NA)

	}
})#UNFOLD
context("running foo NANANANANA")
test_that("nananana",{#FOLDUP
	skip_on_cran()

	x <- rep(NA,20)
	y <- as.integer(x)
	z <- as.logical(y)
	q <- c('a','b','c')
	restart_period <- NA_integer_

	for (thingy in list(x,y,z)) { 
		for (wts in list(NULL,rep(NA_real_,length(thingy)))) {
			for (window in c(15)) {
				for (na_rm in c(FALSE,TRUE)) {
					expect_error(running_sum(thingy,window=window,wts=wts,restart_period=restart_period,na_rm=na_rm),NA)
					expect_error(running_mean(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm),NA)

					for (nw in c(FALSE,TRUE)) { 
						expect_error(running_sd(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_skew(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_kurt(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)

						expect_error(running_sd3(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_skew4(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_kurt5(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_cent_moments(thingy,max_order=5L,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)

						expect_error(running_centered(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)

						expect_error(running_scaled(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_zscored(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_sharpe(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_sharpe(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,compute_se=TRUE,na_rm=na_rm,normalize_wts=nw),NA)
						expect_error(running_tstat(thingy,window=window,min_df=10L,wts=wts,restart_period=restart_period,na_rm=na_rm,normalize_wts=nw),NA)
					}

				}
			}
		}
	}
})#UNFOLD
context("running adjustments run")
test_that("running adjustments",{#FOLDUP
	skip_on_cran()

	set.char.seed("e36291f6-70e0-4412-9c50-bc46b6ab8639")
	x <- rnorm(100)
	y <- as.integer(x)
	z <- as.logical(y)
	q <- c('a','b','c')

	for (thingy in list(x,y,z)) { 
		for (window in c(50,Inf)) {
			for (na_rm in c(FALSE,TRUE)) {
				expect_error(running_centered(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_scaled(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_zscored(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_sharpe(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
				expect_error(running_sharpe(thingy,window=window,restart_period=50L,na_rm=na_rm,compute_se=TRUE),NA)
				expect_error(running_tstat(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
			}
		}
	}

	window <- 10L
	for (thingy in list(x,y,z)) { 
		for (na_rm in c(FALSE,TRUE)) {
			expect_error(running_centered(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
			expect_error(running_scaled(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
			expect_error(running_zscored(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
			expect_error(running_sharpe(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
			expect_error(running_sharpe(thingy,window=window,restart_period=50L,na_rm=na_rm,compute_se=TRUE),NA)
			expect_error(running_tstat(thingy,window=window,restart_period=50L,na_rm=na_rm),NA)
		}
	}

	window <- 10L
	for (thingy in list(x,y,z)) { 
		for (na_rm in c(FALSE,TRUE)) {
			for (lookahead in c(0,-5,10)) {
				expect_error(running_centered(thingy,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
				expect_error(running_scaled(thingy,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
				expect_error(running_zscored(thingy,window=window,restart_period=50L,lookahead=lookahead,na_rm=na_rm),NA)
			}
		}
	}

	for (thingy in list(x,y,z)) { 
		for (min_df in c(2L,10L)) {
			expect_error(running_centered(thingy,window=window,min_df=min_df),NA)
			expect_error(running_scaled(thingy,window=window,min_df=min_df),NA)
			expect_error(running_zscored(thingy,window=window,min_df=min_df),NA)
			expect_error(running_sharpe(thingy,window=window,min_df=min_df),NA)
			expect_error(running_sharpe(thingy,window=window,min_df=min_df,compute_se=TRUE),NA)
			expect_error(running_tstat(thingy,window=window,min_df=min_df),NA)
		}
	}

	expect_error(running_centered(q))
	expect_error(running_scaled(q))
	expect_error(running_zscored(q))
	expect_error(running_sharpe(q))
	expect_error(running_sharpe(q,compute_se=TRUE))
	expect_error(running_tstat(q))

	#expect_error(running_tstat(x,window='FOO'))
	#expect_error(running_tstat(x,window=-20L))
	#expect_error(running_tstat(x,window=20L,restart_period='FOO'))
})#UNFOLD

context("running x y code")
test_that("runs without error",{#FOLDUP
	skip_on_cran()

	set.char.seed("c13a49ac-14e9-462b-b81e-d3a5fc3be491")
	nel <- 20
	xna <- rnorm(nel)
	xna[xna < -0.5] <- NA
	xall <- list(rnorm(nel),
							 xna,
							 as.integer(rnorm(nel,sd=100)))

	wna <- runif(nel,min=1,max=3)
	wna[wna < 1.5] <- NA
	wall <- list(rep(1.0,nel),
							 runif(nel,min=0.9,max=3.5),
							 wna,
							 as.integer(ceiling(runif(nel,min=2,max=100))),
							 as.logical(ceiling(pmax(0,rnorm(nel)))),
							 NULL)

	for (x_thingy in xall) {
		y_thingy <- x_thingy + 1
		for (wts in wall) {
			for (window in c(5,21,Inf,NULL)) {
				for (na_rm in c(FALSE,TRUE)) {
					for (rp in c(1L,40L)) {
						expect_error(running_correlation(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_covariance(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_covariance_3(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_regression_slope(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_regression_intercept(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_regression_fit(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
						expect_error(running_regression_diagnostics(x_thingy,y_thingy,wts=wts,window=window,restart_period=rp,na_rm=na_rm),NA)
					}
				}
			}
		}
	}
})#UNFOLD
test_that("covariance correctness",{#FOLDUP
	skip_on_cran()

	set.char.seed("b81052f6-d7a5-4f3f-95cf-bc8d0030fcf8")
	window <- 30
	maxplus <- 50
	nel <- window + maxplus
	xvec <- rnorm(nel)
	beta_0 <- 0.33
	beta_1 <- 5
	sigma <- 0.5
	yvec <- beta_0 + beta_1 * xvec + rnorm(length(xvec),sd=sigma)
	expect_error(rho <- running_correlation(xvec,yvec,window=window),NA)
	expect_equal(rho[window], cor(xvec[1:window],yvec[1:window]), tolerance=1e-12)
	expect_equal(rho[1+window], cor(xvec[2:(1+window)],yvec[2:(1+window)]), tolerance=1e-12)

	expect_error(rho <- running_covariance(xvec,yvec,window=window,used_df=1),NA)
	expect_equal(rho[window], cov(xvec[1:window],yvec[1:window]), tolerance=1e-12)
	expect_equal(rho[1+window], cov(xvec[2:(1+window)],yvec[2:(1+window)]), tolerance=1e-12)

	expect_error(beta_1 <- running_regression_slope(xvec,yvec,window=window),NA)
	expect_error(beta_0 <- running_regression_intercept(xvec,yvec,window=window),NA)
	mod0 <- lm(yvec[1:window] ~ xvec[1:window])
	ses <- sqrt(diag(vcov(mod0)))

	expect_equal(beta_0[window], coefficients(mod0)[[1]], tolerance=1e-12)
	expect_equal(beta_1[window], coefficients(mod0)[[2]], tolerance=1e-12)
	expect_error(beta_ff <- running_regression_fit(xvec,yvec,window=window),NA)
	expect_equal(beta_ff[,1,drop=FALSE], beta_0, tolerance=1e-12)
	expect_equal(beta_ff[,2,drop=FALSE], beta_1, tolerance=1e-12)
	expect_error(beta_dd <- running_regression_diagnostics(xvec,yvec,window=window),NA)
	expect_equal(beta_dd[,1,drop=FALSE], beta_0, tolerance=1e-12)
	expect_equal(beta_dd[,2,drop=FALSE], beta_1, tolerance=1e-12)
	# also compare against diag(vcov(mod0))
	expect_equal(beta_dd[window,3], summary(mod0)$sigma, tolerance=1e-12)
	expect_equal(beta_dd[window,4], as.numeric(ses[1]), tolerance=1e-12)
	expect_equal(beta_dd[window,5], as.numeric(ses[2]), tolerance=1e-12)

	# and a little bit forward
	for (offs in c(5, maxplus - 1)) {
		mod1 <- lm(yvec[offs + (1:window)] ~ xvec[offs + (1:window)])
		ses <- sqrt(diag(vcov(mod1)))
		expect_equal(beta_0[offs+window], coefficients(mod1)[[1]], tolerance=1e-12)
		expect_equal(beta_1[offs+window], coefficients(mod1)[[2]], tolerance=1e-12)
		expect_equal(beta_dd[offs+window,3], summary(mod1)$sigma, tolerance=1e-12)
		expect_equal(beta_dd[offs+window,4], as.numeric(ses[1]), tolerance=1e-12)
		expect_equal(beta_dd[offs+window,5], as.numeric(ses[2]), tolerance=1e-12)
	}
})#UNFOLD
test_that("covariance weighting correctness",{#FOLDUP
	skip_on_cran()

	set.char.seed("f3d1652c-2d83-4670-998b-f96d18d18374")
	window <- 50
	nel <- window
	xvec <- rnorm(nel)
	beta_0 <- 0.33
	beta_1 <- 5
	sigma <- 0.5
	yvec <- beta_0 + beta_1 * xvec + rnorm(length(xvec),sd=sigma)
	wts <- sample(c(1,2,3),nel,replace=TRUE)
	expect_error(rho <- running_correlation(xvec,yvec,wts=wts,window=window),NA)
	bigx <- rep(xvec,wts)
	bigy <- rep(yvec,wts)
	expect_error(rho2 <- running_correlation(bigx,bigy,window=length(bigx)),NA)
	expect_equal(rho[window],rho2[length(rho2)], tolerance=1e-12)

	expect_error(rho <- running_covariance(xvec,yvec,wts=wts,window=window,normalize_wts=FALSE,used_df=1),NA)
	expect_error(rho2 <- running_covariance(bigx,bigy,window=length(bigx),used_df=1),NA)
	expect_equal(rho[window],rho2[length(rho2)], tolerance=1e-12)

	expect_error(beta_0 <- running_regression_intercept(xvec,yvec,wts=wts,window=window),NA)
	expect_error(beta_1 <- running_regression_slope(xvec,yvec,wts=wts,window=window),NA)
	expect_error(beta_02 <- running_regression_intercept(bigx,bigy,window=length(bigx)),NA)
	expect_error(beta_12 <- running_regression_slope(bigx,bigy,window=length(bigx)),NA)
	expect_equal(beta_0[window],beta_02[length(bigx)], tolerance=1e-12)
	expect_equal(beta_1[window],beta_12[length(bigx)], tolerance=1e-12)

	expect_error(beta_dd <- running_regression_diagnostics(xvec,yvec,wts=wts,window=window,normalize_wts=FALSE),NA)
	expect_error(beta_dd2 <- running_regression_diagnostics(bigx,bigy,window=length(bigx)),NA)
	expect_equal(beta_dd[window,,drop=TRUE],beta_dd2[length(bigx),,drop=TRUE], tolerance=1e-12)
})#UNFOLD

#for vim modeline: (do not edit)
# vim:ts=2:sw=2:tw=79:fdm=marker:fmr=FOLDUP,UNFOLD:cms=#%s:syn=r:ft=r:ai:si:cin:nu:fo=croql:cino=p0t0c5(0:
